Select Distributor

The Distributor is a server that contains the distribution database and stores meta data, history data, and/or transactions. The Distributor can be a separate server from the Publisher (remote Distributor), or it can be the same server as the Publisher (local Distributor). The role of the Distributor varies depending on which type of replication you implement, and in general, its role is much greater for snapshot replication and transactional replication than it is for merge replication.

The Distributor uses these additional resources on the server where it is located:

  • Additional disk space if the snapshot files for the publication are stored on it.

  • Additional disk space to store the distribution database.

  • Additional processor time, which is used by the replication agents running on the Distributor. (Remote agent activation can be used to offload agent processing if necessary).

The server you select as the Distributor should have adequate disk space and processor power to support replication and any other activities based on that server.

Select Make server its own Distributor; SQL Server will create a distribution database and log to make the local server the Distributor. Select Use the following server (the selected server must already be configured as a Distributor) and then click on the name of the server to make a remote server the Distributor.

If you want to use a remote server as the Distributor, make sure the remote server is already configured as a Distributor and the local server is enabled as a Publisher on that Distributor. If the server you want to use as a Distributor is not listed, click Add Server to register it in SQL Server Enterprise Manager and add it to the list of available Distributors.

See Also

Publishers, Distributors, and Subscribers

Remote Agent Activation


Specify Administrative Password

The Distributor requires that you use a password when connecting this Publisher to the Distributor. The password you enter here must be the same as the administrative link password set at the Distributor.

You can change the password on the Distributor tab of the Publisher and Distributor Properties dialog box.

See Also

Connecting to the Distributor

Replication Properties


Specify Snapshot Folder

The Specify Snapshot Folder dialog box appears in the Configure Publishing and Distribution Wizard and in the Create Publication Wizard.

When specifying the snapshot folder in the Configure Publishing and Distribution Wizard, the path you specify will be used as the default snapshot folder for all Publishers enabled in this wizard (the default snapshot folder does not apply to Publishers that are later enabled using Publisher and Distributor Properties).

When specifying the snapshot folder in the Create Publication Wizard, the path you specify will be used as the snapshot folder for the Publisher on which you are creating a publication.

If you use a folder location that requires a login with administrative privileges on the Distributor (for example, a folder located on C$), the share might not be accessible by agents running on other computers, such as agents for pull subscriptions. Prior to implementing replication, test that the replication agents will be able to connect to the snapshot folder by logging on under the security account that will be used by the agents and then try to access the snapshot folder.

Enter the path or use the browse button (...) to specify the location where you want snapshot files stored.

See Also

Alternate Snapshot Locations

Applying the Initial Snapshot


Provide Distribution Database Information

Enter a name for the distribution database. The name can be a maximum of 128 characters but cannot include ~'!%@^&*()+-={}[]|\:;"<>,.?/. The default name for the distribution database is 'distribution'.

You can specify only one distribution database using the Configure Publishing and Distribution Wizard. However, after completing this wizard, you can specify additional distribution databases in the Publisher and Distributor Properties dialog box.

Enter the path and folder for the distribution database file and for the distribution database log file. Paths must refer to disks that are local to the Distributor and begin with a local drive letter and colon (for example, C:). Mapped drive letters and network paths are invalid.

You can decrease the time it takes to write transactions and improve the performance of replication by placing the distribution log on a separate disk drive from the distribution database.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Types of Replication


Enable Publishers

You can give permission for other Publishers to use this Distributor. Select the registered server you want to allow to use this Distributor. Click the properties button (...) next to a Publisher to set the security options, login information, and snapshot folder.

The servers you select as Publishers will use the distribution database created by this wizard. If you want to use a different distribution database than the one created in this wizard, do not enable the Publisher at this time. Instead, use the Publisher and Distributor Properties dialog box to add Publishers after you complete the Configure Publishing and Distribution Wizard.

If you are running Microsoft® Windows NT® 4.0 or Microsoft Windows® 2000 on the Distributor and you want to enable a server that is not listed as a Publisher, click New to register the server in SQL Server Enterprise Manager and add it to the list of available Publishers. Distributors running Microsoft Windows 95 or Windows 98 cannot be Distributors for other Publishers.

Enabling a Publisher to use this server as its Distributor does not make that server a Publisher. You must connect to the Publisher, configure it for publishing, and choose this server as the Distributor.

See Also

Publishers, Distributors, and Subscribers

Replication Properties


Enable Publication Databases

Select the databases that will be enabled to publish snapshot and transactional publications and/or merge publications.

You must be a member of the sysadmin fixed server role to enable a database for publishing. After a database is enabled, a database owner can create publications based on it. An administrator, however, can create a publication without the database having been enabled previously for publication.

If you want to create snapshot or transactional publications based on the database, enable the database for transactional replication. Snapshot replication is the process of copying and distributing data and database objects exactly as they appear at a moment in time. Snapshot replication does not require continuous monitoring of changes because changes made to published data are not propagated to Subscriber(s) incrementally.

With transactional replication, an initial snapshot of data is propagated to Subscribers, and then when data modifications are made at the Publisher, the individual transactions are captured and propagated to Subscribers.

If you want to create merge publications, enable the database for merge replication. Merge replication allows various sites to work autonomously (online or offline) and merge updates made at multiple sites into a single, uniform result at a later time. The initial snapshot is applied to Subscribers, and then SQL Server 2000 tracks changes to published data at the Publisher and at the Subscribers. The data is synchronized between servers either at a scheduled time or on demand. Because updates are made independently (no commit protocol) at more than one server, the same data may have been updated by the Publisher or by more than one Subscriber. Therefore, conflicts can occur when updates are merged.

See Also

Publishers, Distributors, and Subscribers

Types of Replication


Enable Subscribers

Select the Subscribers that will be able to receive publications from this Publisher. You can enable only Subscribers running Microsoft® SQL Server™ in this wizard. Click the properties button (...) next to the Subscriber name to set the security options and default agent schedules.

You can configure a heterogeneous Subscriber in the Publisher and Distributor Properties dialog box after completing the Configure Publishing and Distribution Wizard.

If the server you want to enable as a Subscriber is not listed, click New to register it in SQL Server Enterprise Manager and add it to the list of registered servers.

See Also

Publishers, Distributors, and Subscribers

Replication Properties


Publisher and Distributor Properties, Distributor Tab (Local Distributor)

The following options are available on the Distributor tab of the Publisher and Distributor Properties dialog box when you use a local Distributor.

Options

Name

View the name of the Distributor.

Databases

View the names of the distribution databases.

Properties

Display the properties of the selected distribution database.

New

Add a new distribution database.

Delete

Delete the selected distribution database.

Agent Profiles

Display the profiles for each type of agent.

Administrative Link Password

Enter the password used when a Publisher connects to the Distributor. You can specify certain Publishers as trusted; trusted Publishers do not need a password to connect to the Distributor. If the Publisher is non-trusted, the password you enter here must also be entered when the Publisher is being configured.

Confirm password

Enter the password again to confirm the spelling.

See Also

Connecting to the Distributor

Publishers, Distributors, and Subscribers

Replication Properties


Publisher and Distributor Properties, Distributor Tab (Remote Distributor)

The following options are available on the Distributor tab of the Publisher and Distributor Properties dialog box when you use a remote Distributor.

Options

Distributor for Publisher

View the name of the Publisher.

Distribution server name

View the name of the server where the distribution database is located.

Distribution database

View the name of the distribution database.

Administrative Link Password

Enter the password used by this Publisher to connect to the Distributor. If the Distributor has identified this Publisher as trusted, this control is not displayed on the dialog box.

Confirm password

Enter the password again to confirm the spelling. If the Distributor has identified this Publisher as trusted, this control is not displayed in the dialog box.

See Also

Connecting to the Distributor

Publishers, Distributors, and Subscribers

Replication Properties


Publisher and Distributor Properties, Publishers Tab

The following options are available on the Publishers tab of the Publisher and Distributor Properties dialog box.

Options

Publishers

Select the Publisher to enable from the list of all registered servers. If Microsoft® SQL Server™ 2000 Personal Edition is running on the Distributor, only the local server is listed as an available Publisher, and whether this Publisher is trusted.

Distribution DB

View the name of the distribution database.

(...)

Display and modify the properties of the Publisher including distribution database used, snapshot folder location, and security connection used for the replication agent connection to the Publisher.

Enable All

Enable all the listed Publishers to use this Distributor. If you have installed the Personal Edition, this control is not shown.

Enable None

Clear all the listed Publishers, disabling them from using this Distributor. If SQL Server 2000 Personal Edition is running on the Distributor, this control is not shown.

New

Register a server that does not appear in the list. After the server is registered in SQL Server Enterprise Manager, the server will appear as an available Publisher and you can enable it. If SQL Server 2000 Personal Edition is running on the Distributor, this control is not shown.

See Also

Connecting to the Distributor

Publishers, Distributors, and Subscribers

Replication Properties


Publisher and Distributor Properties, Publication Databases Tab

The following options are available on the Publication Databases tab of the Publisher and Distributor Properties dialog box.

Options

Trans

Enable the database for snapshot replication or transactional replication.

Merge

Enable the database for merge replication.

Database name

View the name of the database.

Transactional - Enable All

Enable all the listed databases for snapshot replication or transactional replication.

Transactional - Enable None

Clear all the listed databases for snapshot replication or transactional replication.

Merge - Enable All

Enable all the listed databases for merge replication.

Merge - Enable None

Clear all the listed databases for merge replication.

Double-clicking on a database name will enable or clear the database for all types of replication.

See Also

Connecting to the Distributor

Publishers, Distributors, and Subscribers

Replication Properties


Publisher and Distributor Properties, Subscribers Tab

The following options are available on the Subscribers tab of the Publisher and Distributor Properties dialog box.

Options

Subscribers

Select the Subscriber to enable. You can then create subscriptions for this Subscriber to publications from this Publisher.

(...)

Display the properties of the selected Subscriber including the security used by replication agents when connecting to the Subscriber and setting the default schedule of the Distribution Agents or Merge Agents.

Enable All

Enable all the listed servers for receiving data from this Publisher.

Enable None

Clear all the listed Subscribers, disabling them from receiving data from this Publisher.

New

Register a new Subscriber that is a SQL Server installation, an installation of Microsoft® Jet 4.0 database (Microsoft Access), an installation of Microsoft Exchange server (if Microsoft Exchange 2000 is installed on this computer), an ODBC data source, or an OLE DB data source. If the new Subscriber is a SQL Server installation, the server will be registered in SQL Server Enterprise Manager.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Subscribing to Publications


Distribution Database Properties, Database Tab (Existing Database)

The following options are available on the Database tab of the Distribution Database Properties dialog box when viewing the properties of an existing distribution database.

Options

Database name

View the name of the distribution database.

These Publishers use this database

View the list of Publishers currently using this distribution database.

Transaction Retention

Reduce the amount of disk space used on the Distributor by minimizing the amount of time for log history and transaction retention.

Store transactions at least

Set the minimum length of time the transaction records are stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The minimum value must be less than the maximum value for storing records.

But not more than

Set the maximum length of time the transaction records are stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The maximum value cannot be less than or equal to the minimum value.

Hours

Use hours as the unit of time for storing transaction records.

Days

Use days as the unit of time for storing transaction records.

History Retention

You can reduce the amount of disk space used on the Distributor by minimizing the amount of time for log history and transaction retention.

Store replication performance history at least

Set the minimum length of time the replication performance history is stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The minimum value must be less than the maximum value for storing performance history.

Hours

Use hours as the unit of time for storing replication performance history.

Days

Use days as the unit of time for storing replication performance history.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Transactional Replication


Distribution Database Properties, Database Tab (Creating New Database)

The following options are available on the Database tab of the Distribution Database Properties dialog box when creating a new distribution database.

Options

Database name

Specify the name of the new distribution database.

Folder for database file

Enter the path for the distribution database file.

(. . .)

Browse for the folder in which to store the distribution database.

Folder for log file

Enter the path for the log file for the distribution database.

(. . .)

Browse for the folder in which to store the log file for the distribution database.

Transaction Retention

Reduce the amount of disk space used on the Distributor by minimizing the amount of time for log history and transaction retention.

Store transactions at least

Set the minimum length of time transactions are stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The minimum value must be less than the maximum value for storing records.

But not more than

Set the maximum length of time transactions are stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The maximum value cannot be less than or equal to the minimum value.

Hours

Use hours as the unit of time for storing transaction records.

Days

Use days as the unit of time for storing transaction records.

History Retention

Reduce the amount of disk space used on the Distributor by minimizing the amount of time for log history and transaction retention.

Store replication performance history at least

Set the minimum length of time replication performance history is stored in the distribution database. If the unit of time is hours, the minimum value is 0 and the maximum value is 32767. If the unit of time is days, the minimum value is 0 and the maximum value is 1365. The minimum value must be less than the maximum value for storing performance history.

Hours

Use hours as the unit of time for storing replication performance history.

Days

Use days as the unit of time for storing replication performance history.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Transactional Replication


Publisher Properties, General Tab

The following options are available on the General tab of the Publisher Properties dialog box for a Publisher running SQL Server.

Options

Publisher

View the name of the Publisher.

Distribution database

If you are enabling a new Publication and there is more than one distribution database at the Distributor, select the distribution database to be used by the Publisher. For a currently enabled Publisher, view the distribution database used by the Publisher.

Snapshot folder

Enter the path and name of the folder to be used to store the snapshots of publications from the Publisher.

Impersonate the SQL Server Agent account on Publisher (trusted connection)

Use the same Windows Authentication account used by SQL Server Agent on the Publisher.

Use SQL Server Authentication

Use SQL Server Authentication with specified login and password.

Login name

Enter the login name for the account.

Password

Enter the password for the account.

Confirm password

Enter the password for the account again to confirm it.

Administrative Link to the Distributor

Select This Publisher requires a password to establish a link to the Distributor to mark the Publisher as non-trusted by the Distributor. A password is needed to connect to the Distributor, and you can specify that password on the Distributor tab of the Publisher and Distributor Properties dialog box.

This option appears only if the Publisher and Distributor are configured on different servers.

See Also

Publishers, Distributors, and Subscribers

Replication Properties


Publisher Properties, General Tab (Heterogeneous Publisher)

The following options are available on the General tab of the Publisher Properties dialog box for a heterogeneous Publisher.

Options

Heterogeneous Publisher

View the name of the heterogeneous Publisher.

Distribution database

View the distribution database used by the Publisher.

Snapshot folder

View the path and name of the folder used to store the snapshots of publications from the Publisher.

Subscribers

Select the Subscriber that can receive published data from this Publisher.

Enable All

Enable all the listed Subscribers to receive data from this Publisher.

Enable None

Clear all the listed Subscribers, disabling them from receiving data from this Publisher.

New Subscriber

Register a new Subscriber that is a Microsoft® SQL Server™ installation, an installation of Microsoft Access (Microsoft Jet 4.0 database), an ODBC data source, or an OLE DB data source.

See Also

Heterogeneous Publishers

Publishers, Distributors, and Subscribers

Replication Properties


Subscriber Properties, General Tab

The following options are available on the General tab of the Subscriber Properties dialog box.

Options

Subscriber

View the name of the Subscriber.

Type

View the type of Subscriber (SQL Server, Microsoft® Jet 4.0 database, Microsoft Exchange server, ODBC, or OLE DB).

Description

Enter or modify the description of the Subscriber.

Impersonate the SQL Server Agent account on Distributor (trusted connection)

Use the same Windows Authentication account used by SQL Server Agent on the Distributor.

Use SQL Server Authentication of this account

Use SQL Server Authentication with a specified login and password.

Login name

Enter the login name for the SQL Server account.

Password

Enter the password for the SQL Server account.

Confirm password

Enter the password for the account again to confirm it.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Subscribing to Publications


Subscriber Properties, Schedules Tab

The following options are available on the Schedules tab of the Subscriber Properties dialog box. These options are available for the Distribution Agents and the Merge Agents.

Options

Continuously

Set the default schedule that is used when new agents are created to run the agent at all times.

At the following scheduled times

Set the default schedule that is used when new agents are created to run the agents according to the specified schedule.

Change

Set the job schedule for the agents.

See Also

Publishers, Distributors, and Subscribers

Replication Properties

Subscribing to Publications


Create Publication Wizard, Welcome

The Welcome page of the Create Publication Wizard includes a description of the Create Publication Wizard and an option to select advanced options during the wizard.

If you enable Show advanced options in this wizard and you create a snapshot or transactional publication, you will be able to enable the publication for:

  • Updatable subscription options for immediate updating and/or queued updating.

  • Transforming data as it is published using Data Transformation Services (DTS).

When creating a merge publication, you will see all the options available whether the Show advanced options in the wizard check box is selected or not.

Updatable Subscriptions

Typically, replicated data is read-only. However, in Microsoft® SQL Server™ 2000, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions with snapshot replication or transactional replication or by using merge replication. If you need to modify data at the Subscriber using snapshot replication or transactional replication, you can choose immediate updating, queued updating, or immediate updating with queued updating as a failover.

Transforming Published Data

Transformable subscriptions (available with snapshot replication or transactional replication) leverages the data movement, transformation mapping, and filtering capabilities of Data Transformation Services (DTS). Using transformable subscriptions in your replication topology allows you to customize and send published data based on the requirements of individual Subscribers.

Examples of how you can use transformable subscriptions include:

  • Creating column and horizontal partitions of published data on a per Subscriber basis (custom data partitions).

  • Creating data transformations such as data type mappings (for example, integer to real data type), column manipulations (for example, concatenating first name and last name columns), string manipulations, and use of functions.

See Also

Publishing Data and Database Objects

Replication Wizards

Transforming Published Data

Updatable Subscriptions


Choose Publication Database

Select the name of the database that contains the data and database object that you want to publish.

The publication database is the database on the Publisher that is the source of data and database objects to be replicated. Each database used in replication must be enabled as a publication database by a member of the sysadmin server role, either through the Configure Publishing and Distribution Wizard, the Publisher and Distributor properties, by using the sp_replicationdboption system stored procedure, or by creating a publication on that database using the Create Publication Wizard.

See Also

Publishers, Distributors, and Subscribers

Publishing Data and Database Objects


Select Publication Type

Microsoft® SQL Server™ 2000 provides these types of publications: snapshot, transactional, and merge. Each type provides different capabilities depending on your application, and different levels of ACID properties (atomicity, consistency, isolation, durability) of transactions and site autonomy.

For example, merge replication allows users to work and update data autonomously, although ACID properties are not assured. Instead, when servers are reconnected, all sites in the replication topology converge to the same data values.

Transactional replication maintains transactional consistency, but Subscriber sites are not as autonomous as they are in merge replication because Publishers and Subscribers generally should be connected continuously for updates to be propagated to Subscribers.

Snapshot replication distributes data exactly as it appears at a specific moment in time and does not monitor for updates to the data. Snapshot replication is best used as a method for replicating data that changes infrequently, or where the most up-to-date values (low latency) are not a requirement. When synchronization occurs, the entire snapshot is generated and sent to Subscribers.

It is possible for the same application to use multiple replication types and options. Some of the data in the application may not require any updates at Subscribers, some sets of data may require updates infrequently, with updates made at only one or a few servers, while other sets of data may need to be updated daily at multiple servers.

Which type of replication you choose for your application depends on your requirements based on distributed data factors, whether or not data will need to be updated at the Subscriber, your replication environment, and the needs and requirements of the data that will be replicated.

Note If you are running Microsoft SQL Server 2000 Personal Edition, Transactional publication appears shaded. The license for the Personal Edition does not permit the creation of transactional publications. However, you can still subscribe to transactional publications. To create transactional publications at this server, SQL Server 2000 Standard Edition or SQL Server 2000 Enterprise Edition must be installed.

See Also

Planning for Replication

Publishing Data and Database Objects

Types of Replication


Updatable Subscriptions, Create Publication Wizard

With snapshot replication or transactional replication, replicated data is by read-only by default; however, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions. If you need to modify data at the Subscriber using snapshot or transactional replication, you can choose one of the following options depending on your requirements.

Updatable Subscription | Requirements
Immediate Updating | Publisher and Subscriber must be connected to update data at the Subscriber.
Queued Updating | Publisher and Subscriber do not have to be connected to update data at the Subscriber. Updates can be made while offline.
Immediate Updating with Queued Updating as a Failover | Publisher and Subscriber are connected most of the time, but you may occasionally need to make updates offline.

The following options are available on the Updatable Subscriptions page of the Create Publication Wizard.

Options

Immediate updating

Enables immediate updating. Immediate updating allows data modifications to replicate data at the Subscriber. Those changes are then sent back to the Publisher and to other Subscribers. Immediate updating ensures that there are no conflicts. Data modifications are propagated from the Subscriber to the Publisher using two-phase commit protocol (2PC).

Queued updating

Enables queued updating. Queued updating allows data modifications to replicated data at the Subscriber without requiring an active network connection to the Publisher. When you create a publication with the queued updating option enabled and INSERT, UPDATE, or DELETE statements are performed on replicated data at the Subscriber, the changes are stored in a queue. The queued transactions are applied asynchronously at the Publisher when network connectivity is restored. You can use either SQL Server queues (default) or Microsoft Message Queuing.

Select both Immediate updating and Queued updating to enable immediate updating with queued updating as a failover. Immediate updating with queued updating as a failover can be used when you expect the Publisher and Subscribers to be connected, but you do not want to lose the ability to make updates at the Subscriber if a system failure results in the loss of network connectivity. Immediate updating with queued updating as a failover allows you to use immediate updating and switch to queued updating when needed.

After you enable immediate updating and/or queued updating when creating the publication, you will also need to specify the updatable subscription option when creating subscriptions to the publication.

Note You cannot enable or disable immediate updating or queued updating after the publication is created by modifying Publication Properties. Updatable subscriptions and transforming published data are mutually exclusive options. If you choose to enable updatable subscriptions, you cannot also enable transforming published data (another option available with snapshot and transactional publications).

See Also

Transactional Replication

Updatable Subscriptions


Transform Published Data

Transforming published data (available with snapshot replication or transactional replication) leverages the data movement, transformation mapping, and filtering capabilities of Data Transformation Services (DTS). Using transformable subscriptions in your replication topology allows you to customize and send published data based on the requirements of individual Subscribers.

Examples of how you can use transformable subscriptions include:

  • Creating column and horizontal partitions of published data on a per-Subscriber basis (custom data partitions).

  • Creating data transformations such as data type mappings (for example, integer to real data type), column manipulations (for example, concatenating first name and last name columns), string manipulations, and use of functions.

The following options are available on the Transform Published Data page of the Create Publication Wizard.

Options

Yes, transform the data

Enables the transformation of published data. Transforming published data allows you to attach a DTS package to a subscription so that data is transformed as it is published.

No, all Subscribers receive data directly

Disables the transformation of published data.

After the transformation of published data is enabled, you can build a replication DTS package using the Transform Published Data Wizard. You will need to attach the DTS package as part of the subscription process. Transforming published data is supported for Microsoft® SQL Server™ 2000 and OLE DB Subscribers (ODBC Subscribers are not supported).

Note You cannot enable or disable the transformation of published data after the publication is created by modifying Publication Properties.

See Also

Transactional Replication

Transforming Published Data


Specify Subscriber Types

Subscribers are servers that receive replicated data. Subscribers subscribe to publications, not to individual articles within a publication, and they subscribe only to the publications that they need, not necessarily all of the publications available on a Publisher.

A subscription is the request for data or database objects to be published to a specific Subscriber. A Subscriber can have several subscriptions to different publications.

Subscribers can be servers running Microsoft® SQL Server™ 2000, earlier versions of SQL Server, or heterogeneous data sources. For merge replication, Subscribers can also be devices running Microsoft SQL Server for Windows® CE Edition.

The following options are available on the Specify Subscriber Types page of the Create Publication Wizard.

Options

Select one or more of the types of Subscribers that will subscribe to this publication.

Servers running SQL Server 2000

Subscribers running SQL Server 2000 can subscribe to this publication.

Servers running SQL Server version 7.0

Subscribers running SQL Server version 7.0 can subscribe to this publication. If you select this option, you will only see publication properties in this wizard that are compatible with SQL Server 7.0 Subscribers.

Devices running SQL Server CE

Devices running Microsoft SQL Server 2000 Windows CE Edition (SQL Server CE) can subscribe to merge publications using anonymous subscriptions. If you enable this type of Subscriber, anonymous subscriptions will also be enabled and cannot be disabled. This option is available only if you are creating a merge publication.

Heterogeneous data sources, such as Oracle or Microsoft Access

Subscribers running heterogeneous data sources or SQL Server version 7.0 or earlier can subscribe to this publication. Subscribers running SQL Server version 7.0 or earlier can subscribe to snapshot or transactional publications, but not to merge publications. Subscribers running Oracle, Microsoft Access, and other heterogeneous data sources can subscribe to snapshot or transactional publications. Subscribers running Microsoft Access can subscribe to merge publications.

The version requirement for Subscribers to a publication is determined by the properties of the publication, not by the types of Subscribers selected on this page. For example, if servers running SQL Server 2000 is the only option selected, but you do not enable any of the new properties that require Subscriber to run SQL Server 2000, Subscribers running SQL Server 7.0 would still be able to subscribe to this publication.

See Also

Publishers, Distributors, and Subscribers

Subscribing to Publications


Specify Articles

Select the object to publish as an article. Articles can be all or filtered partitions of a table, or can be database objects such as stored procedures, views and user-defined functions.

Determine what articles to include in the publication based on the type of replication you are using and requirements of the specific article. If you are publishing a database object that references other database objects, you must publish all objects referenced by the object. For example, the Products Above Average Price view on the Northwind database retrieves data from the PRODUCTS tables. If you publish this view, you must also publish the PRODUCTS tables as part of the publication.

To filter data in a table, continue in the Create Publication Wizard and you will be able to filter horizontally or vertically for any type of publication, and for merge publications, you can create dynamic filters and/or join filters.

If you are creating a merge publication and you indicated that Subscribers would be running SQL Server version 7.0 or earlier, a clock icon will appear on any tables that contain timestamp columns. Publishing timestamp columns as part of merge replication was not available in SQL Server version 7.0 or earlier, and when Subscribers are running SQL Server version 7.0 or earlier, they are limited to the functionality of that version. You will not be able to publish data from these tables without first removing the timestamp columns.

An article cannot be published both in a merge publication and in a snapshot or transactional publication that allows updatable subscriptions. If the article has been specified for a merge publication and you are creating a snapshot or transactional publication that allows updatable subscriptions, a merge icon will appear next to the table name on the Specify Articles page indicating that the article cannot be included in the new publication.

If the article has been specified for a snapshot or transactional publication that allows updatable subscriptions and you are creating a merge publication, a red circle with a slash will appear next to the table on the Specify Articles page indicating that the article cannot be included in the new publication.

The table must have a primary key for it to be published as part of a transactional publication. If you are creating a transactional publication, a key icon with an X over it will appear next to tables that do not have primary keys. Tables with this icon cannot be included in the new publication.

The best use of default article properties is to set the defaults for an object type before creating any articles of that type. If you create articles first, and then change the defaults, you will be prompted whether to update the properties of the previously published articles. SQL Server overwrites all properties that have defaults in articles that have previously been published. This may affect more properties than you intended. The default properties that you set do not persist outside of this wizard. When you open Publication Properties, the defaults may not be the same as what you defined in this wizard.

See Also

Filtering Published Data

Planning for Each Type of Replication

Publishers, Distributors, and Subscribers

Publishing Data and Database Objects

Replication Between Different Versions of SQL Server


Article Issues

You may receive a message stating that you have an article issue after you select the articles that you want to publish. This messages states conditions that have been found and actions, if any, performed by Microsoft® SQL Server™ 2000.

Article Issue | Details
uniqueidentifier columns will be added to tables. | SQL Server requires that all merge articles contain a uniqueidentifier column with a unique index and the ROWGUIDCOL property. SQL Server will add a uniqueidentifier column to published tables that do not have one when the first snapshot is generated. For more information, see Merge Replication.
timestamp columns will be added to tables. (for Publishers running SQL Server 7.0). | SQL Server requires that all articles in a publication allowing updatable subscriptions contain a timestamp column used for tracking changes to the replicated data. SQL Server will add a timestamp column to those published tables that do not have one. For more information, see Immediate Updating.
Uniqueidentifier columns will be added to tables. | SQL Server requires that all articles in a publication allowing updatable subscriptions contain a uniqueidentifier column named 'MSrepl_tran_version' used for tracking changes to the replicated data. SQL Server will add such a column to published tables that do not have one. For more information, see Updatable Subscriptions.
IDENTITY columns require the NOT FOR REPLICATION option. | SQL Server requires that all IDENTITY columns use the NOT FOR REPLICATION option. If a published IDENTITY column does not use this option, INSERT commands may not replicate properly. For more information, see Using NOT FOR REPLICATION.
IDENTITY property not transferred to Subscribers. | Because this publication does not allow updatable subscriptions, when IDENTITY columns are transferred to the Subscriber, the IDENTITY property will not be transferred. (For example, a column defined as INT IDENTITY at the Publisher will be defined as INT at the Subscriber.) For more information, see Using IDENTITY Values with Replication.
Tables referenced by views are required. | SQL Server requires that all tables referenced by published views and indexed views be available at the Subscriber. If the referenced tables are not published as articles in this publication, they must be created at the Subscriber manually. For more information, see Publishing Data and Database Objects.
Objects referenced by stored procedures are required. | SQL Server requires that all objects referenced by published stored procedures, such as tables and user-defined functions, be available at the Subscriber. If the referenced objects are not published as articles in this publication, they must be created at the Subscriber manually. For more information, see Publishing Data and Database Objects.
Indexed view articles are supported only in SQL Server 2000, Enterprise Edition. | Indexed views are supported only in Microsoft SQL Server 2000, Enterprise Edition. You have published one or more indexed view articles that create an indexed view at the Subscriber. For Subscribers that are servers running Microsoft SQL Server, only those running SQL Server 2000, Enterprise Edition will be able to subscribe to this publication. For more information, see Publishing Data and Database Objects.
Heterogeneous Subscribers may not support BIGINT IDENTITY columns. | You have enabled identity range management for one or more published tables that contain a BIGINT IDENTITY column. Some heterogeneous Subscribers may not support the IDENTITY property or automatic IDENTITY value management for this column. Such Subscribers may allow IDENTITY column values that could result in duplicate key violations or other synchronization conflicts. For more information, see Managing Identity Values.


Customize the Properties of the Publication

You can choose to accept the default properties for the publication, or you can choose to define properties such as filtering data, enabling anonymous subscriptions, and setting the schedule of the Snapshot Agent.

Accepting the default properties for the publication is the fastest way to finish the wizard and create your publication. However, there are some options that cannot be changed after the publication is created.

Choose Yes, I will define data filters, enable anonymous subscriptions, or customize other properties if you want to:

  • Publish only certain rows or columns from a table.

  • Allow anonymous subscriptions.

  • Specify whether to make snapshots always available to immediately synchronize new subscriptions.


Filter Data

Choose whether you want to filter the publication vertically (by restricting the columns that are published) or horizontally (by restricting the rows that are published). You need to enable filtering here in order to be able to filter when creating the publication (using this wizard).

Enabling horizontal filters includes being able to create dynamic filters and join filters for merge publications.

By filtering published data, you can:

  • Minimize the amount of data sent over the network.

  • Reduce the amount of storage space required at the Subscriber.

  • Customize publications and applications based on individual Subscriber requirements.

  • Avoid or reduce conflicts because the different data partitions can be sent to different Subscribers (no two Subscribers will be updating the same data values).

Fully replicated database designs publish all database tables to remote locations. However, to maximize application performance and reduce the amount of remote storage required, or to restrict the availability of certain data to specific Subscribers, you should publish only the minimum amount of data required. Your publication can include both unfiltered and filtered tables. For example, you could include the complete (unfiltered) table of company products and the filtered table of customers for a specific region.

You can limit the set of published data by filtering an article according to specific attributes. For example, it is advisable to filter the table rows when sites or regions in the replicated topology only need access to certain rows in the database. If you are creating a snapshot or transactional publication, it is advisable to filter table columns when there is limited network capacity or when Subscribers have limited capacity to store large text or image columns. Merge publications do not support filters on table columns.

Note If you do not enable filtering for this publication on this page of the Create Publication Wizard, you will not be able to filter table articles in this wizard.

See Also

Filtering Published Data


Filter Table Columns

Column filters restrict the columns to be included as part of a snapshot, transactional or merge publication. Column filters can reduce the time it takes to propagate data updates to Subscribers, reduce the storage space needed at the Subscriber, and limit the data in a publication to data that is needed by individual Subscribers.

Select the columns to be included in the publication. In the list of columns in the article, you can check or clear the box to the left of the column name to indicate whether the column is included or excluded from the article.

Columns that are part of the primary key for the table (as indicated by a key icon in place of the check box) cannot be excluded from the publication.

If it is a merge publication or if the snapshot or transactional publication allows immediate updating or queued updating subscriptions, timestamp columns (as indicated by the clock icon in place of the check box) cannot be excluded from the publication.

The following columns cannot be excluded:

Column Type 		Type of publication and/or options Icon displayed next to column
primary key | Transactional publications | primary key
timestamp | Snapshot or transactional publication that allows immediate updating and/or queued updating | clock
uniqueidentifier column | Merge publications | disabled checkbox
msrepl_tran_version | Snapshot or transactional publication that allows immediate updating and/or queued updating | disabled checkbox
columns that do not allow NULL and do not have default values
  • Merge publications

  • Snapshot or transactional publication that allows immediate updating and/or queued updating
 disabled checkbox

See Also

Column Filters


Enable Dynamic Filters

You can tailor the subset of data sent to the individual needs of each Subscriber by setting dynamic filters on table articles. The dynamic filter examines the characteristics of the Subscriber and then forwards the appropriate data as defined in the filter. This allows you to create a single publication that provides different data sets to different Subscribers or groups of Subscribers.

You must create the dynamic filter manually using a function such as SUSER_SNAME() to determine which data is propagated to which Subscribers.

Dynamic snapshots provide a performance advantage when applying the snapshot of a merge publication with dynamic filters. By using Microsoft® SQL Server™ 2000 bulk copy files to apply data to a specific Subscriber instead of a series of INSERT statements, you will improve the performance when applying the initial snapshot for dynamically filtered merge publications. For more information, see Dynamic Snapshots.

Select Yes, enable dynamic filters to enable the publication to use dynamic filters. You will not be able to change this property in the Publication Properties dialog box after the publication is created.

See Also

Dynamic Filters


Generate Filters Automatically

To define a static filter in your table, identify a table in your database that contains at least one column of the characteristics on which to filter.

To define a dynamic filter, identify a table in your database that contains at least one column of hostnames and one column of a host characteristic on which to filter. For example, the following table has one column containing hostnames and one column containing the host's region.

Hostname | Region
Smith | 5
Smith | 6
Jones | 2
Green | 1

The table is the starting point for a filter on hostnames that can be extended automatically to filter related tables. In this example, applying a filter to return only rows for Smith would result in Microsoft® SQL Server™ 2000 also including the rows for regions 5 and 6 in any related tables. If you do not have a suitable table in your database, you must create one.

For either static or dynamic filters, select from the list the table in your database that contains the column(s) of data used in the first filter. Then enter the conditions to be used in extending the first filter to another column(s) of data in the tables. Enter only the conditions to be used in the filter. Do not enter the entire SELECT statement, and do not enter the WHERE keyword. For example, enter only:

sales.rep = SUSER_SNAME()

instead of

WHERE sales.rep = SUSUER_SNAME()

After you complete this wizard page, SQL Server will generate a tentative list of JOIN filters to display in the next wizard dialog box.

See Also

Filtering Published Data


Filter Table Rows

You can filter the rows in a table to reduce the amount of data being published. The filter statement must refer only to columns and values in that table. Filters cannot refer to data in other tables to determine whether rows of this table are included or excluded.

Click the properties button (...) to enter the WHERE clause used as the filter.

Using row filters, you can specify a subset of rows from a table to be published. Row filters can be used when only specific rows need to be propagated to Subscribers, to eliminate rows that users do not need to see (such as rows that contain sensitive or confidential information), or to create different partitions of data that are sent to different Subscribers. For those applications that can, publishing different partitions of data to different Subscribers can also help avoid conflicts that would otherwise be caused by multiple Subscribers updating the same data values.

If you are creating a merge publication, you can extend filtering to a related table by creating a join filter, or if you have enabled dynamic filters for the publication, you can specify a user-defined function or system function for the row filter.

To specify a dynamic filter for a merge publication

  • Click the properties button (...) to enter the WHERE clause and use a system function, such as SUSER_SNAME(), or a user-defined function as the criteria for the filter.

To specify a join filter for a merge publication

  1. Filter the rows in a table by clicking the properties button (...) to enter the WHERE clause used as the filter.

  2. Click the Create JOIN statement under the Filtered Table column. The table name that is being filtered in the row filter appears as a row.

  3. Click under Table to Filter and select the table to filter from the drop down box.

  4. Click on the properties button (...) under JOIN Filter Clause and enter the WHERE clause used for the join filter.

See Also

Dynamic Filters

Join Filters

Row Filters


Specify Filter

Enter only the conditions to be used in the filter. The SELECT * FROM . . . WHERE statement has already been supplied and cannot be modified. For example, enter only:

sales.rep = SUSER_SNAME()

See Also

Row Filters


Specify Filter (<<TABLE>> Keyword)

Enter only the conditions to be used in the filter. The SELECT <published columns> FROM <<TABLE>> WHERE statement has already been supplied and cannot be modified. Add the necessary filter in the WHERE clause. If you use a table name in the WHERE clause, you must use <<TABLE>> instead of the table name. For example, enter only:

<<TABLE>>.salesrep = SUSER_SNAME()

See Also

Row Filters


Specify Join Filter

Enter only the conditions to be used in the filter. The SELECT*FROM . . . ON statement has already been supplied and cannot be modified. For example, enter only:

CUSTOMER.CUST_ID = ORDERS.CUST_ID

Any column names that are identical in both tables and, therefore, could resolve to either table, should be qualified with the name of the table.

See Also

Join Filters


Validate Subscriber Information, Create Publication Wizard

With merge replication dynamic filters, you use a function that references Subscriber information. Microsoft® SQL Server™ 2000 validates Subscriber information based on that function before each merge. This ensures that information is partitioned consistently with each merge.

For example, when a publication is dynamically filtered using the function SUSER_SNAME(), the Merge Agent applies the initial snapshot to each Subscriber based on data that is valid for the SUSER_SNAME() expression.

When the Subscriber reconnects to the Publisher for the next synchronization, the Merge Agent validates the information at the Subscriber and ensures that the same partitions are synchronized as were originally sent as part of the initial snapshot.

Select Yes, validate Subscriber information if you want the Subscriber information to be validated during each merge. Then enter all functions used in dynamic filters for this publication.

Select No, do not validate Subscriber information if you do not want the Subscriber information validated during each merge.

After you create the publication, you cannot change this property in the Publication Properties dialog box.

See Also

Validate Subscriber Information


Optimize Synchronization

Optimizing synchronization during merge replication allows you to minimize network traffic when determining if recent changes have caused a row to move into or out of a partition for a Subscriber. In merge replication, an option is provided that stores more information at the Publisher instead of transferring that information over the network to the Subscriber. While this option may result in a larger database at the Publisher, it can improve synchronization performance by making filter evaluation more efficient and minimizing network traffic over a slow link. However, more information will be stored at the Publisher and additional storage space will be necessary.

If the optimize synchronization setting is not used, changes in one partition will cause the merge process to verify the partition content of data sent to all Subscribers again, even if the change affects only one or a few Subscribers.

Select Yes, minimize the amount of data if you want to store more information at the Publisher instead of sending it over the network to the Subscriber.

Select No, do not minimize the amount of data if you want the information to be sent over the network to the Subscriber.

See Also

Optimizing Synchronization


Allow Anonymous Subscriptions

An anonymous subscription is a type of pull subscription for which detailed information about the subscription and the Subscriber are not stored. Initiated at the Subscriber, the Subscriber is responsible for keeping an anonymous subscription synchronized.

Select Yes, allow anonymous subscriptions to allow Subscribers unknown to the Publisher to subscribe to this publication. You will not be able to change this property in the Publication Properties after the publication is created.

If Devices running SQL Server CE was enabled on the Subscriber Types page of the Create Publication Wizard, this option for anonymous subscriptions cannot be disabled. Subscribers running SQL Server CE must use anonymous subscriptions.

See Also

Anonymous Subscriptions


article Properties, General Tab (Snapshot or Transactional Publication)

The following options are available on the General tab of the article Properties dialog box.

Options

Name

If creating a new article, enter the name of the article. If the article is already created, view the name of the article.

Description

Enter or change the description of the article.

Source table owner

View the name of the owner of the table on which the article is based.

Source table name

View the name of the table on which the article is based.

Destination table owner

If creating a new article, enter the name of the table owner. If the article is already created, view the name of the table owner.

Destination table name

If creating a new article, enter the name of the table. If the article is already created, view the name of the table.

Provide support for horizontal partitions created by DTS transformation scripts.

Enables the publication to use horizontal DTS partitions. Using transformable subscriptions and partitioning data horizontally, you can exclude certain rows on a per Subscriber basis. This option is visible only if the publication allows transformation of published data.

See Also

Publishing Data and Database Objects


article Properties, General Tab (Merge Publication)

The following options are available on the General tab of the article Properties dialog box.

Options

Name

If creating a new article, enter the name of the article. If the article is already created, view the name of the article.

Description

Enter or change the description of the article.

Source table owner

View the name of the owner of the table on which the article is based.

Source table name

View the name of the table on which the article is based.

Destination table owner

If creating a new article, enter the name of the table owner. If the article is already created, view the name of the table owner.

Treat changes to the same row as a conflict

Define a conflict as the same row being changed at the same time by two sites.

Treat changes to the same column as a conflict (changes to different columns in the same row will be merged).

Define a conflict as the same column of the same row being changed at the same time by two sites.

See Also

Publishing Data and Database Objects


article Properties, Snapshot Tab

The following options are available on the Snapshot tab of the article Properties dialog box.

Options

Keep the existing table unchanged

Keep all the existing data and schema in the Subscriber table with the same name as the destination table.

DROP the existing table and re-create it

Delete the Subscriber table that has the same name as the destination table and create a new table locally that is identical to the table at the Publisher.

Delete data in the existing table that matches the row filter statement

Delete the data that matches the data to be replicated from the Publisher in the Subscriber table with the same name as the destination table. Data in the local table that does not match the data to be replicated remains unchanged in the local table.

Delete all data in the existing table

Delete all the data but keep the table schema in the Subscriber table with the same name as the destination table.

Include declared referential integrity

Copy all primary key constraints, reference constraints, and unique constraints to the destination table if they exist on the source table at the Publisher.

Clustered indexes

Copy clustered indexes to the destination table if they exist on the source table at the Publisher.

Nonclustered indexes

Copy nonclustered indexes to the destination table if they exist on the source table at the Publisher.

User triggers

Copy user triggers to the destination table if they exist on the source table at the Publisher.

Extended properties

Copy extended properties to the destination table if they exist on the source table at the Publisher.

Collation

Copy collation specifications to the destination database if they exist on the source database at the Publisher.

Convert user-defined to base data types

Convert the user-defined types to the original data types on which they were based if there are user-defined data types in the source table at the Publisher. Converting user-defined data types to base data types may alter the formatting and other characteristics of the data.

See Also

Applying the Initial Snapshot

Publishing Data and Database Objects


article Properties, Commands Tab

The following options are available on the Commands tab of the article Properties dialog box. This tab is not displayed for snapshot or merge publications, or for transactional publications that allow immediate updating or queued updating subscriptions or transactional publications that allow transformations of published data.

Options

Replace INSERT commands with this stored procedure call

Use a custom stored procedure at each Subscriber in place of the INSERT command published by the Publisher. You can use the stored procedure named and created automatically, or you can use your own specified custom stored procedure. If you specify that all Subscribers are running SQL Server, this option is automatically selected. If you include heterogeneous Subscribers, you must clear this option for the heterogeneous Subscriber to receive the INSERT commands.

Replace UPDATE commands with this stored procedure call

Use a custom stored procedure at each Subscriber in place of the UPDATE command published by the Publisher. You can use the stored procedure named and created automatically, or you can use your own specified custom stored procedure. The custom stored procedure must be specified with an M call. If you specify that all Subscribers are running SQL Server, this option is automatically selected. If you include heterogeneous Subscribers, you must clear this option for the heterogeneous Subscriber to receive the UPDATE commands.

Replace DELETE commands with this stored procedure call

Use a custom stored procedure at each Subscriber in place of the DELETE command published by the Publisher. You can use the stored procedure named and created automatically, or you can use your own specified custom stored procedure. If you specify that all Subscribers are running SQL Server, this option is automatically selected. If you include heterogeneous Subscribers, you must clear this option for the heterogeneous Subscriber to receive the DELETE commands.

Create the stored procedures specified above during initial synchronization of the Subscribers

Create the stored procedures automatically at the Subscriber because they do not exist there. If you have created your own custom stored procedures at the Subscriber, clear this option.

Send parameters in binary format

Send the stored procedures in the most efficient format.

Use column names in commands that are not replaced by stored procedures

Use the table column names in all SQL statements.

See Also

Transactional Replication

Using Custom Stored Procedures in Articles


article Properties, Resolver Tab

The following options are available on the Resolver tab of the article Properties dialog box. This tab shows on the article properties for merge publications.

Options

Use the default resolver

Have the resolver that ships with Microsoft® SQL Server™ 2000 handle conflicts detected during the merge process.

Use this custom resolver (registered at the Distributor)

Have a custom resolver handle the conflicts detected during the merge process. Select the custom resolver to be used for this article. Twelve custom resolvers are available with SQL Server 2000.

Require verification of a digital signature before merging

Replication signature verification constants are used to specify whether to verify a digital signature before using a resolver in merge replication.

Enter information needed by the resolver

Enter the name of the stored procedure to call when using the stored procedure resolver and enter any parameters or other information it requires. You can also enter information required by other custom resolvers.

Allow Subscribers to resolve conflicts interactively during on-demand synchronizations

Activated at run-time, the Interactive Resolver displays data for each conflicting row, and provides options for viewing and editing the conflict data, and resolving each conflict individually. If resolving conflicts interactively is allowed, you must also specify whether to resolve conflicts interactively when a subscription is created.

See Also

Merge Replication Conflict Detection and Resolution


article Properties, Identity Range Tab

In replication topologies where a publication contains an identity column and where new rows can be inserted at Subscribers, additional configuration may be necessary to ensure that no duplicate identity values or constraint violations occur.

The Identity Range Tab allows you to specify that SQL Server™ 2000 will assign and manage identity columns automatically by allocating ranges of identity values to the Publisher and all the Subscribers.

The following options are available on the Identity Range tab of the article Properties dialog box.

Options

Automatically assign and maintain a unique identity range for each subscription

SQL Server will assign the identity ranges for the Publisher and for each subscription to this article.

Maximum identity value

View the maximum identity value that will be entered for a row in this replicated table.

Next range starting value

View the next available starting identity value.

Identity Increment

View the increment with which identity values are generated.

Range size of Publisher

Enter the identity range size reserved for INSERTs made at the Publisher.

Range size of Subscribers

Enter the identity range size reserved for INSERTs made at Subscribers.

Assign a new range when this percentage of values is used

When INSERT values on this article reach this percentage of the existing identity range, SQL Server will assign a new identity range.

Note Changing the values on this dialog box affect all articles based on this table. All articles in all publications that are based on this table use the same identity range properties.

See Also

Identity Ranges with Immediate Updating and Queued Updating

Managing Identity Values

Publishing Data and Database Objects


article Properties, Merging Changes Tab

SQL Server™ 2000 provides the option to validate permissions for a Subscriber to upload data changes to a Publisher. This verifies that the Merge Agent login has the permissions to perform INSERT, UPDATE, and DELETE commands on the publication database. Validating permissions requires that the Merge Agent login be a valid user with the appropriate permissions in the publication database.

This permissions validation is in addition to the verification that the logins used at the Subscriber are in the publication access list (PAL).

If you set the check permissions option after the initial snapshot has been generated, a new snapshot must be generated and reapplied at the Subscriber in order for permissions to be validated when data changes are merged.

The following options are available on the Merging Changes tab of the article Properties dialog box.

Options

INSERT

Select to have SQL Server verify that the Merge Agent login has permissions to perform INSERT commands.

UPDATE

Select to have SQL Server verify that the Merge Agent login has permissions to perform UPDATE commands.

DELETE

Select to have SQL Server verify that the Merge Agent login has permissions to perform DELETE commands.

Multicolumn updates

Enables SQL Server to generate one UPDATE statement for all changes to multiple column values in the same row. If you open the article properties, Merging Changes tab while in the Create Publication Wizard, you can modify this option. If you open the article properties, Merging Changes tab while in the Publication Properties after the publication is created, you will be able to view this option, but you will not be able to modify it.

See Also

Merge Replication

Merge Replication Conflict Detection and Resolution


Stored Procedure Article Properties, General Tab

The following options are available on the General tab of the Stored Procedure Article Properties dialog box.

Any object referenced by the stored procedure (such as tables or functions) should also be published or should be created manually at each Subscriber.

When you publish these objects, the definitions are replicated as part of the initial snapshot applied at the Subscriber. Subsequent changes to the definition of these objects are not copied automatically to Subscribers.

Options

Name

If creating a new stored procedure article, enter the name of the article. If the article is already created, view the name of the article.

Source Stored Procedure Owner

View the owner for the stored procedure to be published.

Source Stored Procedure Name

View the name of the stored procedure to be published.

Destination Stored Procedure Owner

Enter or view the owner of the replicated stored procedure after it is published to the Subscriber.

Destination Stored Procedure Name

View the name of the replicated stored procedure after it is published to the Subscriber.

Description

Enter a description for the stored procedure article.

See Also

Publishing Data and Database Objects


Stored Procedure Article Properties, Other Tab

The following options are available on the Other tab of the Stored Procedure Article Properties dialog box.

Options

Keep the existing stored procedure

If the stored procedure already exists at the Subscriber, keep the existing stored procedure at the Subscriber but do not publish this stored procedure.

Drop the existing stored procedure

If the stored procedure already exists at the Subscriber, drop the stored procedure at the Subscriber and publish this stored procedure.

For stored procedure articles in transactional publications that do not allow updatable subscriptions, you can publish the execution of the stored procedure in addition to the schema of the stored procedure. For more information, see Publishing Stored Procedure Execution.

Never replicate the schema only

Does not replicate the execution of the stored procedure.

Every time it is executed

Always replicate the execution of the stored procedure.

Only when it is executed inside a serializable transaction

Replicate the stored procedure when it is executed inside a serializable transaction.

Extended properties

Publishes all extended properties that exist with this stored procedure article.

See Also

Publishing Data and Database Objects


View Article Properties, General Tab

After you create views, they will appear as objects in the Create Publication Wizard in the Specify Articles dialog box.

When you replicate these objects, the definitions are replicated as part of the initial snapshot applied at the Subscriber. Subsequent changes to the definition of these objects are not copied automatically to Subscribers. However, replicating the definition of these objects can provide a convenient mechanism for deploying these components of your application to Subscribers.

Any objects referenced by the view (such as tables or functions) should also be published or should be created manually at each Subscriber.

The following options are available on the General tab of the View Article Properties dialog box.

Options

Name

If creating a new view article, enter the name of the article. If the article is already created, view the name of the article.

Source View Owner

View the owner for the view to be published.

Source View Name

View the name of the view to be published.

Destination View Owner

Enter or view the owner of the replicated view after it is published to the Subscriber.

Destination View Name

View the name of the replicated view after it is published to the Subscriber.

Description

Enter a description for the view article.

See Also

Publishing Data and Database Objects


View Article Properties, Snapshot Tab

The following options are available on the Snapshot tab of the View Article Properties dialog box.

Options

Keep the existing view

If a view with the same name already exists at the Subscriber, keep the existing view at the Subscriber and do not publish this view.

Drop the existing view

If a view with the same name already exists at the Subscriber, drop the view at the Subscriber and publish this view.

Extended properties

Publishes all extended properties that exist with this view article.

User Triggers

Publishes all user triggers that exist with this view article.

See Also

Publishing Data and Database Objects


User-Defined Function Article Properties, General Tab

After you create views, user-defined functions, and stored procedure definitions in a database, they will appear as objects in the Create Publication Wizard in the Specify Articles dialog box.

When you replicate these objects, the definitions are replicated as part of the initial snapshot applied at the Subscriber. Subsequent changes to the definition of these objects are not copied automatically to Subscribers. However, replicating the definition of these objects can provide a convenient mechanism for deploying these components of your application to Subscribers.

Any object referenced by the function should also be published or should be created manually at each Subscriber.

The following options are available on the General tab of the User-defined Function Article Properties dialog box.

Options

Name

If creating a new user-defined function article, enter the name of the article. If the article is already created, view the name of the article.

Source User-Defined Function Owner

View the owner for the user-defined function to be published.

Source User-Defined Function Name

View the name of the user-defined function to be published.

Destination User-Defined Function Owner

Enter or view the owner of the replicated user-defined function after it is published to the Subscriber.

Destination User-Defined Function Name

View the name of the replicated user-defined function after it is published to the Subscriber.

Description

Enter a description for the user-defined function article.

See Also

Publishing Data and Database Objects

User-defined Functions

User-Defined Functions and Dynamic Filters


User-Defined Function Article Properties, Snapshot Tab

The following options are available on the Snapshot tab of the User-defined Function Article Properties dialog box.

Options

Keep the existing user-defined function

If a user-defined function with the same name already exists at the Subscriber, keep the existing user-defined function at the Subscriber and do not publish this user-defined function.

Drop the existing user-defined function

If a user-defined function with the same name already exists at the Subscriber, drop the user-defined function at the Subscriber and publish this user-defined function.

Extended properties

Publishes all extended properties that exist with this user-defined function article.

See Also

Publishing Data and Database Objects

User-defined Functions


Indexed View Article Properties, General Tab

After you create indexed views, they will appear as objects in the Create Publication Wizard in the Specify Articles dialog box.

When you replicate these objects, the definitions are replicated as part of the initial snapshot applied at the Subscriber. Subsequent changes to the definition of these objects are not copied automatically to Subscribers. However, replicating the definition of these objects can provide a convenient mechanism for deploying these components of your application to Subscribers.

When publishing indexed views that are not schema-only articles for snapshot replication or transactional replication, you do not have to replicate the view as a table. When the view is published to the Subscriber, a table is created on the Subscriber that contains the data the view is based upon. Indexing a view as a table at a Subscriber can be a convenient way of replicating the contents of a view without requiring that each of the tables that comprise the view definition are replicated as well.

Any objects referenced by the indexed view (such as tables or functions) should also be published or should be created manually at each Subscriber.

The following options are available on the General tab of the Indexed View Article Properties dialog box.

Options

Name

If creating a new indexed view article, enter the name of the article. If the article is already created, view the name of the article.

Source View Owner

View the owner for the indexed view to be published.

Source View Name

View the name of the indexed view to be published.

Destination View Owner

Enter or view the owner of the replicated object after it is published to the Subscriber.

Destination View Name

View the name of the replicated object after it is published to the Subscriber.

Description

Enter a description for the indexed view article.

In snapshot and transactional publications that do not allow updatable subscriptions, you can specify whether indexed view articles create an indexed view or a table at the Subscriber. Indexed view articles in merge publications always create an indexed view at the Subscriber.

An indexed view

Create an indexed view at the Subscriber. This option is not displayed for merge publications.

A table defined by the source indexed view

Create a table at the Subscriber containing the data at the Publisher defined by the indexed view. This option is not displayed for merge publications.

See Also

Publishing Data and Database Objects


Indexed View Article Properties, Snapshot Tab

The following options are available on the Snapshot tab of the Indexed View Article Properties dialog box.

Options

Keep the existing view

If an object with the same name as the destination object already exists at the Subscriber, keep the existing object at the Subscriber and do not publish this indexed view.

Drop the existing view

If object already exists at the Subscriber, drop the indexed view at the Subscriber and publish this indexed view.

Nonclustered indexes

Publishes all nonclustered indexes that exist with this indexed view article. This option is required if the destination object is an indexed view.

Extended properties

Publishes all extended properties that exist with this indexed view article.

User Triggers

Publishes all user triggers that exist with this indexed view article.

See Also

Publishing Data and Database Objects


Push Subscription Wizard, Welcome

The Welcome page of the Create Push Subscription Wizard includes a description of the Create Push Subscription Wizard and an option to select advanced options during the wizard.

If you enable Show advanced options in this wizard and you create a push subscription for a snapshot or transactional publication, you will be able to configure the subscription for:

  • Updatable subscription options for immediate updating and/or queued updating.

  • Running the agent at a location other than the Distributor.

When creating a push subscription to a merge publication, you will see all the options available whether the Show advanced options in the wizard check box is selected or not.

Updatable Subscriptions

Typically, replicated data is read-only. However, in SQL Server™ 2000, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions with snapshot replication or transactional replication or by using merge replication. If you need to modify data at the Subscriber using snapshot replication or transactional replication, you can choose immediate updating, queued updating or immediate updating with queued updating as a failover.

For more information, see Updatable Subscriptions.

Remote Agent Activation

Remote agent activation allows you to reduce the amount of processing on the Distributor or Subscriber by running the Distribution Agent or Merge Agent on another computer and then activating that agent remotely using Distributed Component Object Model (DCOM).

You can implement remote agent activation on either push or pull subscriptions. With each type of subscription, you need to:

  • Indicate where the agent will run in the Push Subscription or Pull Subscription Wizard.

  • Configure DCOM to activate an agent remotely.

  • Configure or create the subscription indicating where the agent should run.

See Also

Push Subscriptions

Remote Agent Activation

Replication Wizards

Subscribing to Publications


Choose Subscribers

Select the data source that will subscribe to this publication. You can make multiple selections by holding down the CTRL key. Selecting a group name selects all the servers in that group.

The Enabled Subscribers group includes all Subscribers (both Microsoft® SQL Server™ and heterogeneous data sources) that were enabled as Subscribers previously. If a Subscriber is missing from the list, cancel the wizard, and then use Subscribers tab in the Publisher and Distributor Properties (in Enterprise Manager, right-click the Replication folder and click Configure Publishing, Subscribers and Distribution) to enable it.

Note If you are publishing to heterogeneous Subscribers or Subscribers running SQL Server version 7.0 or earllier, the snapshot format must be set to character mode.


Set Merge/Distribution Agent Location

When creating a push subscription, the Merge Agent (for merge publications) or the Distribution Agent (for snapshot and transactional publications) runs at the Distributor by default.

You can offload agent processing to another server while still maintaining administration control at the Publisher and Distributor. Offloading agent processing is only supported for Subscribers on Microsoft Windows® 2000 or Windows NT® 4.0.

Select Run the agent at the Distributor if you do not want to offload agent processing.

Select Run the agent at the Subscriber (supported only for Windows 2000 and Windows NT Subscribers) if you want to offload agent processing. Then verify or enter the computer name of the Subscriber.

See Also

Remote Agent Activation


Initialize Subscription

If you want Microsoft® SQL Server™ to initialize the subscription, select Yes, initialize the schema and data. After the subscription is created, the Distribution Agent or Merge Agent will run and apply the snapshot files to the Subscriber.

If you manually load the schema and data at the Subscriber, for example, using backup tapes, you do not need to initialize the subscription. Select No, the Subscriber already has the schema and data if you do not want SQL Server to apply the snapshot.

If the publication property to synchronize immediately is enabled, and the Snapshot Agent has not run, or the publication is not set to synchronize immediately, select Start the Snapshot Agent to initialize the subscription immediately to start the Snapshot Agent. If the Merge Agent or Distribution Agent is not set to run continuously, the snapshot will be applied when that agent runs according to its schedule.

If the publication property to synchronize immediately is enabled, and the snapshot has not been generated for the publication, this option will indicate that you must start the Merge Agent or Distribution Agent after the snapshot is available.

If the publication property to synchronize immediately is enabled, the snapshot has been generated, and the Merge Agent or Distribution Agent is set to run continuously, the Start the Snapshot Agent to initialize the subscription immediately check box is not displayed.

See Also

Applying the Initial Snapshot


Set Subscription Priority

When you create a subscription, you can either assign it a priority value or use the Publisher as a proxy for the Subscriber when resolving conflicts.

A subscription with an assigned priority value is called a global subscription; a subscription using the priority value of the Publisher is called a local subscription. This table summarizes the main differences and uses of each type.

Type | Priority Value | Used
Global. | Assigned by user. | When you want different Subscribers to have different priorities.
Local (includes anonymous). | 0.00, but the Publisher acts as a proxy for data changes after the Subscriber synchronization with the Publisher. | When you want all Subscribers to have the same priority, and the first Subscriber to merge with the Publisher to win the conflict. Anonymous subscriptions are helpful when you expect to have a large number of Subscribers and you do not want to keep track of them at the Publisher/Distributor.

When you change a row in a global subscription, the subscription priority is stored in the meta data for the change. This priority value travels with the changed row as it merges with changes at other Subscribers. This assures that a change made by a higher priority subscription does not lose to a change made by a subscription with a lower priority.

If a row is changed in a local subscription, no priority is assigned to the change until the row merges with the other changes at a Publisher. During the merge process at the Publisher, the changes from the Subscriber are assigned the priority of the Publisher and travel with that priority as it merges with changes at other Publishers and Subscribers. In a sense, the Publisher assumes authorship of the change.

Global subscriptions provide a greater number of options and allow for greater sophistication to a conflict resolution scheme than local subscriptions. Using global subscriptions ensures that priority values are preserved throughout the enterprise.

Global subscriptions can also be specified as alternate synchronization partners for subscriptions to this publication. (Alternate synchronization partners are specified in the Publication Properties dialog box.)

Local subscriptions are also appropriate (and usually required) in a topology with several levels, where Subscribers are leaf nodes. In these topologies, any nodes that republish data must be global Subscribers; local Subscribers can be used only at the leaf nodes.

Select Use the Publisher as a proxy for the Subscriber when resolving conflicts if you want this to be a local subscription.

Select Use the following priority . . . and then enter a priority number for the subscription if you want this to be a global subscription.

See Also

Merge Replication Conflict Detection and Resolution

Subscriber Types and Conflicts


Updatable Subscriptions, Subscription Wizards

With snapshot replication or transactional replication, replicated data is by default read only; however, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions. If you need to modify data at the Subscriber using snapshot or transactional replication, you can choose one of the following options depending on your requirements.

Updatable Subscription | Requirements
Immediate Updating | Publisher and Subscriber must be connected to update data at the Subscriber.
Queued Updating | Publisher and Subscriber do not have to be connected to update data at the Subscriber. Updates can be made while offline.
Immediate Updating with Queued Updating as a Failover | Publisher and Subscriber are connected most of the time, but you may occasionally need to make updates offline.

Options

None – changes are not replicated

Replicated data that is modified at the Subscriber will not be propagated to the Publisher or other Subscribers.

Immediate updating

Configures this subscription to use immediate updating. Immediate updating allows data modifications to replicated data at the Subscriber. Those changes are then sent back to the Publisher and to other Subscribers. Immediate updating ensures that there are no conflicts. Data modifications are propagated from the Subscriber to the Publisher using two-phase commit protocol (2PC).

Queued updating

Configures this subscription to use queued updating. Queued updating allows data modifications to replicated data at the Subscriber, without requiring an active network connection to the Publisher. When you create a publication with the queued updating option enabled and a INSERT, UPDATE, or DELETE statements are performed on replicated data at the Subscriber, the changes are stored in a queue. The queued transactions are applied asynchronously at the Publisher when network connectivity is restored. You can use either SQL Server queues (default) or Microsoft Message Queuing.

Immediate updating with queued updating as a standby in case of failure

Configures the subscription for immediate updating with queued updating as a failover. Immediate updating with queued updating as a failover can be used when you expect the Publisher and Subscribers to be connected, but you do not want to lose the ability to make data modifications at the Subscriber if a system failure results in the loss of network connectivity. Immediate updating with queued updating as a failover allows you to use immediate updating and switch to queued updating when needed.

Note You cannot configure immediate updating or queued updating after the subscription is created by modifying Push Subscription Properties or Pull Subscription Properties.

See Also

Transactional Replication

Updatable Subscriptions


Specify DTS Package

If transforming published data has been enabled in the publication, you must specify the DTS package to use with this subscription.

These are the options available on the Specify DTS Package page of the Create Push Subscription Wizard.

Options

Distributor

Select this option if the DTS package is located at the Distributor.

Subscriber

Select this option if the DTS package is located at the Subscriber.

List Packages

If you select the Subscriber option and the Subscriber is running SQL Server, you can also click the List Packages button. This will connect to the Subscriber and retrieve the list of packages created for use with replication. Such packages can be created manually or by using the Define Transformation of Published Data Wizard.

Package name

Enter the name of the DTS package that will be used with this subscription.

Owner Password (if required)

Enter the owner password for the DTS package if required.

See Also

Transforming Published Data


Start Required Services

The services listed on this wizard page must be running for Microsoft® SQL Server™ to synchronize changes. SQL Server Agent is required for all publications. MS DTC is required for transactional and snapshot publications that allow updatable subscriptions (immediate updating and/or queued updating). Microsoft Message Queuing is required for transactional and snapshot publications that allow queued updating subscriptions and use Microsoft Message Queuing to queue data modifications made at the Subscriber.

The SQL Server Agent icon, MS DTC icon, or Microsoft Message Queuing icon before the service indicates whether the service is currently running or stopped. If the icon is shaded, the state of the service is unknown.

If the required service is not currently running, you can either select the service and have SQL Server start the service automatically when this wizard is finished, or start the service manually later.


Pull Subscription Wizard, Welcome

The Welcome page of the Create Pull Subscription Wizard includes a description of the Create Pull Subscription Wizard and an option to select advanced options during the wizard.

If you enable Show advanced options in this wizard and you create a pull subscription for a snapshot or transactional publication, you will be able to configure the subscription for:

  • Updatable subscription options for immediate updating and/or queued updating.

When creating a pull subscription to a merge publication, you will see all the options available whether the Show advanced options in the wizard check box is selected or not.

Updatable Subscriptions

Typically, replicated data is read-only. However, in SQL Server 2000, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions with snapshot replication or transactional replication or by using merge replication. If you need to modify data at the Subscriber using snapshot replication or transactional replication, you can choose immediate updating, queued updating or immediate updating with queued updating as a failover.

For more information, see Updatable Subscriptions.

See Also

Pull Subscriptions

Replication Wizards

Subscribing to Publications


Choose Publication

When you expand a Publisher, SQL Server Enterprise Manager displays the publications that meet these requirements:

  • Your current login is included in the publication access list for that publication.

  • The current server is an enabled Subscriber at the Publisher or the publication allows anonymous subscriptions.

If the publication you want to subscribe to is not in the list, add the login used at the Subscriber to the publication access list for the publication. To add a login to the PAL:

  1. Click Cancel to exit the Create Pull Subscription Wizard.

  2. In Enterprise Manager, connect to the Publisher and right-click the publication that you want to subscribe to.

  3. Click Properties, and then on the Publication Access List tab, add the login used at the Subscriber.

If the current server is not enabled as a Subscriber at the Publisher, add the Subscriber. To add a Subscriber for this Publisher:

  1. Click Cancel to exit the Create Pull Subscription Wizard.

  2. In Enterprise Manager, connect to the Publisher and right-click the Replication folder and then click Configure Publishing, Subscribers, and Distribution.

  3. On the Subscribers tab, select the box to the left of the Subscriber name. If the Subscriber is not listed, click New Subscriber, than click the type of Subscriber to register, and enter the server and connection information.

If the publication does not allow anonymous subscriptions, change this property. To enable anonymous subscriptions:

  1. Click Cancel to exit the Create Pull Subscription Wizard.

  2. In Enterprise Manager, connect to the Publisher and right-click the publication that you want to allow anonymous subscriptions, and then click Properties.

  3. On the Subscription Options tab, select Allow anonymous subscriptions.

See Also

Anonymous Subscriptions

Pull Subscriptions

Subscribing to Publications


Look for Publication

These are the options available on the Look for Publication page of the Create Pull Subscription Wizard.

Options

Look at publications from registered servers

Select this option to view publications at registered servers.

Look at publications in the Active Directory or specify publication information

Select this option to view publications that are listed in Microsoft® Active Directory™. If allowed, you will be able to subscribe to publications listed in Active Directory. This option is for Publishers running SQL Server 2000.

See Also

Active Directory Services


Specify Publication

These are the options available on the Specify Publication page of the Create Pull Subscription Wizard.

Options

Publisher

Enter the computer name of the Publisher.

Browse (...)

Select to browse for Publisher information in Microsoft® Active Directory™.

Publication database

Enter the name of the publication database.

Publication

Enter the name of the publication.

Connect using Windows Authentication

Select to use Windows Authentication to connect to the Publisher.

Connect using SQL Server Authentication

Select to use SQL Server Authentication to connect to the Publisher.

Login

Type the login for the SQL Server account.

Password

Type the password for the SQL Server account.

See Also

Active Directory Services


Specify Updating Subscription Login

The publication access list determines which logins have permissions to update the data in the publication. Be sure the login you specify is included in the publication access list for this publication.

See Also

Publication Access Lists

Subscribing to Publications


Snapshot Delivery

The publication being subscribed to allows Subscribers to use alternate snapshot locations or file transfer protocol (FTP) to download the snapshot file over the Internet. If the Subscriber does not have direct network access to the snapshot files at the time the subscription is initialized, Microsoft® SQL Server™ can copy the snapshot file over the Internet using FTP.

Select Use snapshot files from the default snapshot folder for this publication to access snapshot files in the default location for this Publisher.

Select Use snapshot files from the following folder to specify another location that the Subscriber can access where the snapshot files are located.

See Also

Alternate Snapshot Locations

Applying the Initial Snapshot


Set Distribution Agent Schedule

Specify the schedule for the Distribution Agent to run for this subscription. Select Continuously to guarantee that data modifications will be propagated immediately between the Publisher and the Subscriber.

Selecting Using the following schedule runs the Distribution Agent hourly (default), or daily, weekly, or monthly. However, choosing a frequency other than Continuously increases the latency between the Subscriber and the Publisher.

Select On demand only to run the Distribution Agent only when specifically requested. This option also enables a Subscriber to use Microsoft Windows Synchronization Manager.

See Also

Distribution Agents

Replication Agents

Windows Synchronization Manager


Set Merge Agent Schedule

Specify the schedule for the Merge Agent to run for this subscription. Select Continuously to guarantee that data modifications will be propagated immediately between the Publisher and the Subscriber.

Selecting Using the following schedule runs the Merge Agent hourly (default), or daily, weekly, or monthly. However, choosing a frequency other than Continuously increases the latency between the Subscriber and the Publisher.

Select On demand only to run the Merge Agent only when specifically requested. This option also enables a Subscriber to use Microsoft Windows Synchronization Manager.

See Also

Merge Agents

Replication Agents

Windows Synchronization Manager


Allow Anonymous Subscription

An anonymous subscription is a type of pull subscription for which detailed information about the subscription and the Subscriber are not stored. Initiated at the Subscriber, the Subscriber is responsible for keeping an anonymous subscription synchronized.

Select Yes, make the subscription anonymous to make this an anonymous subscription.

Select No, this is a named subscription to make this a pull subscription for which detailed information is stored.

See Also

Anonymous Subscriptions

Pull Subscriptions

Subscribing to Publications


Specify Subscriber Security

This Subscriber has been registered in Enterprise Manager to require the user to enter a password when connecting to the Subscriber. Select the connection information to be used by the replication agents. Select By impersonating the SQL Server Agent account on server to use the same Windows Authentication account used by SQL Server Agent on the server. Select Using SQL Server Authentication of this account to use SQL Server Authentication of a specified account.

You can change the password later on the Security tab of the Pull Subscription Properties.

See Also

Replication Properties

Replication Security

Subscribing to Publications


publication Properties, General Tab

The following options are available on the General tab of the publication Properties dialog box.

Options

Name

View the name of the publication.

Database

View the name of the database containing the publication.

Description

Enter or change the description of the publication.

Type

View the type of publication (snapshot, transactional, or merge).

List the publication in the Active Directory

Select to enable the publication in the Microsoft® Windows® Active Directory™ Services available on Microsoft Windows 2000. This will allow users at Subscribers to view the publication, and if allowed, subscribe to the publication.

Subscriptions expire and are dropped if not synchronized in the following number of hours/days

Set the number of hours for snapshot and transactional publication, or the number of days for merge publications. This is the number of hours or days in which synchronization needs to occur, otherwise the subscription will be dropped.

Subscriptions never expire

Allows subscriptions to exist even if they haven't synchronized. For snapshot and transactional publications, the subscription will be deactivated until it is reinitialized.

See Also

Subscription Deactivation and Expiration

Publishing Data and Database Objects


publication Properties, Articles Tab

The following options are available on the Articles tab of the publication Properties dialog box.

Options

(check box)

Enable the selected object as an article.

Object Type

Types of objects in the publication database that can be published as articles.

Show

Click this checkbox to display the objects of this type in the article list.

Publish All

Select this checkbox to publish all objects of this type that can be published as articles in this publication. (Some objects cannot be published. For example, tables without primary key columns cannot be published as part of transactional publications, so selecting this option will publish all tables that have primary keys).

Owner

View the name of the owner of the object.

Object

View the name of the table, stored procedure, view, user-defined function or indexed view on which the article is based.

(...)

Display the properties of the article.

Ariticle Defaults

Set the default properties for new articles based on selected type of object.

Show unpublished objects

Displays objects that were not marked for publishing in the publication.

See Also

Publishing Data and Database Objects


publication Properties, Filter Columns Tab

The following options are available on the Filter Columns tab of the publication Properties dialog box.

Options

Owner

View the name of the owner of the table.

Table

View the name of the table on which the article is based.

Article

View the name of the article.

(check box)

Include or exclude a table column from the selected article. Columns that are part of the primary key for the table, as indicated by a key icon in the column, cannot be excluded from the article.

The following columns cannot be excluded from a publication.

Column Type | Type of Publication and Options | Icon
Primary key | Transactional publication | Primary key
Timestamp | Snapshot or transactional publications that allow updatable subscriptions | Clock
uniqueidentifier | Merge publications | Disabled check box
msrepl_tran_version | Snapshot or transactional publications that allow updatable subscriptions | Disabled check box
columns that do not allow NULL and do not have default values | Merge publications Snapshot or transactional publications that allow updatable subscriptions | Disabled check box

Column name

View the name of the column.

Data type (Base Type)

View the data type of the column. If the data type is based on another data type, the base data type is shown in parenthesis.

Add column to table

Allows you to add a column on the publishing table that can then be included in the publication.

Drop selected column

Allows you to drop a column from the publication and from the publishing table.

See Also

Column Filters

Filtering Published Data

Schema Changes on Publication Databases


publication Properties, Filter Rows Tab

The following options are available on the Filter Rows tab of the publication Properties dialog box.

Options

Owner

View the name of the owner of the table.

Table

View the name of the table on which the article is based.

Article

View the name of the article.

Filter clause

View the clause used to filter the rows included in the article.

(...)

Enter or modify the filter clause.

See Also

Filtering Published Data

Row Filters


publication Properties, Filter Rows Tab (merge publication)

The following options are available on the Filter Rows tab of the publication Properties dialog box.

Options

Owner

View the name of the owner of the table.

Table

View the name of the table on which the article is based.

Article

View the name of the article.

Filter clause

View the clause used to filter the rows included in the article.

(...)

Enter or modify the filter clause.

Filtered table

Select the name of the filtered table. Only tables that either have a row filtered or are filtered through a JOIN are displayed in this column. Select Delete JOIN to remove an existing JOIN.

Table to filter

Select the name of the table to which filtering is extended.

Join filter clause

View the JOIN clause used to extend the filtering from Filtered table to Table to filter.

(...)

Enter or modify the JOIN clause.

See Also

Dynamic Filters

Filtering Published Data

Join Filters

Row Filters


publication Properties, Subscriptions Tab

The following options are available on the Subscriptions tab of the publication Properties dialog box.

Options

Subscription name

View the name of the subscription.

Type

View the type of subscription (push or pull).

Priority

View the priority of the subscription. This option is displayed only for merge publications. A priority of 0 indicates that the Subscriber is using the Publisher as a proxy for changes when resolving data conflicts. This option is displayed only for merge publications.

All Articles

View whether this subscription contains all articles in the publication. This option is displayed only for snapshot and transactional publications.

Push New

Create a new push subscription for this publication.

Properties

Display the properties of the selected subscription.

Delete

Delete the selected subscription.

Reinitialize

Reinitialize the selected subscription.

Reinitialize All

Reinitialize all subscriptions listed.

View Conflicts

View the synchronization conflicts for the selected subscription. This option is displayed only for merge publications and for snapshot and transactional publications that use updatable subscriptions. This option is not shown for heterogeneous publications.

Transformations

Start the Transform Published Data Wizard, which helps you create a DTS package to transform data as it is published. This option is displayed only for snapshot and transactional publication that allow transforming published data. This option is not shown for heterogeneous publications.

Dynamic Snapshot

Start the Create Dynamic Snapshot Job Wizard. This option is only displayed for merge publications that allow dynamic filters. This option is not shown for heterogeneous publications.

Limit the number of concurrent merge processes to the following

Limit the number of merge processes that can run at the same time to the specified number. This option is displayed only for merge publications. This option is not shown for heterogeneous publications.

See Also

Subscribing to Publications


publication Properties, Subscription Options Tab (Snapshot or Transactional Publication)

The following options are available on the Subscription Options tab of the publication Properties dialog box.

Options

Use a Distribution Agent that is independent of other publications from this database

Select whether the publication uses an independent Distribution Agent or whether multiple push subscriptions to publications from this publication database to the same Subscriber and subscription database share one Distribution Agent. Sharing the same Distribution Agent reduces the resource demands and increases performance at the Distributor. You must use an independent Distribution Agent if you want to have anonymous subscriptions for this publication or use attachable subscription databases.

Snapshot files are always available to initialize new subscriptions

Select whether to continuously maintain a current snapshot of the publication so that new subscriptions can be initialized as soon as the subscription is created. You must select this if you want to allow anonymous subscriptions or attachable subscription databases.

Allow anonymous pull subscriptions

Select to allow anonymous subscriptions for this publication.

Allow new subscriptions to be created by attaching a copy of a subscription database

Select whether to allow new subscriptions to be created by attaching a copy of a subscription database.

Allow pull subscriptions

Select whether those Subscribers who have been specifically enabled are allowed to create pull subscriptions to the publication. Subscribers are enabled on the Subscribers tab of the Publisher and Distributor Properties dialog box.

Data Transformation Services

View whether or not DTS can be used to transform the data as it is published.

See Also

Replication Agents

Subscribing to Publications

Transforming Published Data


publication Properties, Subscription Options Tab (Merge Publication)

The following options are available on the Subscription Options tab of the publication Properties dialog box.

Options

Allow pull subscriptions

Select whether Subscribers that have been specifically enabled are allowed to create pull subscriptions to the publication. Subscribers are enabled to create pull subscriptions on the Subscribers tab of the Publisher and Distributor Properties dialog box.

Allow anonymous subscriptions

Select to allow anonymous subscriptions for this publication.

Allow new subscriptions to be created by attaching a copy of a subscription database

Select whether to allow new subscriptions to be created by attaching a copy of a subscription database.

Centralize conflicting reporting at the Publisher

Select whether all data conflicts are reported at the Publisher or whether a conflict is reported at the location where the conflict occurred, either at the Publisher or at a Subscriber.

Allow partitioning through dynamic filters

Specify whether the merge publication allows dynamic filters.

Minimize network traffic by increasing the storage requirements at the Publisher

Select to optimize synchronization so that network traffic is minimized when determining if recent changes have caused a row to move into or out of a partition for a Subscriber.

See Also

Dynamic Filters

Merge Replication

Optimizing Synchronization


publication Properties, Subscription Options Tab (SQL Server 7.0 Transactional Publication)

The following options are available on the Subscription Options tab of the publication Properties dialog box.

Options

Use a Distribution Agent that is independent of other publications from this database

Select whether the publication uses a separate Distribution agent. Having all the publications at the Publisher use the same Distribution Agent reduces the resource demands and increases performance at the Distributor. However, if your application requires immediate synchronization or allows anonymous subscriptions, you must have a separate Distribution Agent for this publication.

Snapshot files are always available to immediately initialize new subscriptions

Select whether to continuously maintain a current snapshot of the publication so that new subscriptions can be initialized as soon as the subscription is created.

Allow anonymous Subscribers to pull subscriptions

Select whether anonymous Subscribers are allowed to create pull subscriptions to the publication.

Allow enabled Subscribers to pull subscriptions

Select whether those Subscribers who have been specifically enabled are allowed to create pull subscriptions to the publication. Subscribers are enabled on the Subscribers tab of the Publisher and Distributor Properties dialog box.

Allow snapshots to be downloaded using FTP (File Transfer Protocol)

Select whether enabled Subscribers or anonymous Subscribers can use file transfer protocol (FTP) to download the snapshot file over the Internet.

Allow immediate updating subscriptions

View whether a Subscriber can modify subscription data and have those changes replicated to the Publisher.


publication Properties, Updatable Tab

With snapshot replication or transactional replication, replicated data is by default read only; however, you have the ability to modify replicated data at the Subscriber by using updatable subscriptions. If you need to modify data at the Subscriber using snapshot or transactional replication, you can choose one of the following options depending on your requirements.

The following options are available on the Updatable tab of the publication Properties dialog box.

Options

Allow immediate updating subscriptions

View whether this publication allows data modifications made at the Subscriber to be immediately propagated to the Publisher and then to other Subscribers. You cannot change this property after the publication is created. If you need to change it, you will have to delete the publication and re-create it.

Allow queued updating subscriptions

View whether this publication allows data modifications made at the Subscriber to be stored in a queue and propagated to the Publisher at a later time. You cannot change this property after the publication is created. If you need to change it, you will have to delete the publication and re-create it.

Report conflicting data changes at the Publisher only

Specifies that conflict reporting will occur only at the Publisher. If you clear this option, conflict reporting will occur at the Publisher and Subscriber.

Keep the change made at the Publisher

Select to indicate that when a conflict occurs, the data change made at the Publisher wins the conflict.

Keep the change made at the Subscriber

Select to indicate that when a conflict occurs, the data change made at the Subscriber wins the conflict.

Reinitialize the subscription

Select to indicate that when a conflict occurs, the subscription will be reinitialized.

In a SQL Server database

Select to indicate that data modifications made at the Subscriber will be stored in a SQL Server database. This option is only available if queued updating is enabled.

Using Microsoft Message Queuing

Select to indicate that data modifications made at the Subscriber will be stored using Microsoft Message Queuing. This option is only available if queued updating is enabled.

See Also

Planning for Replication Options

Queued Updating Conflict Detection and Resolution

Updatable Subscriptions


publication Properties, Snapshot Tab

The following options are available on the Snapshot tab of the publication Properties dialog box.

Options

Native SQL Server format – all Subscribers must be servers running SQL Server

Specifies that the snapshot files will be in native SQL Server format.

Character mode format - supports heterogeneous Subscribers and data transformations using DTS

Specifies that the snapshot files will be in character mode format.

Do not lock tables during snapshot generation. All Subscribers must be servers running SQL Server version 7.0 or later.

Select this option to enable concurrent snapshot processing. This option is displayed with transactional replication. Publishing tables will not be locked while the snapshot is generated.

Before applying the snapshot, execute this script

Enter the network path for the script that you want executed before the snapshot is applied.

After applying the snapshot, execute this script

Enter the network path for the script that you want executed before the snapshot is applied.

(. . . )

Browse to the location of the script that needs to be executed.

See Also

Applying the Initial Snapshot

Executing Scripts Before and After the Snapshot is Applied

How Transactional Replication Works


publication Properties, Snapshot Location Tab

Alternate snapshot locations enable you to store snapshot files in a location other than, or in addition to, the default location, which is often located at the Distributor. Alternate locations can be on another server, on a network drive, or on removable media such as CD-ROMs or removable disks.

The following options are available on the Snapshot Location tab of the publication Properties dialog box.

Options

Generate snapshots in the normal snapshot folder

Specifies that the snapshot files will be stored in the default snapshot folder for this Publisher. To modify the snapshot folder for this Publisher (which affects all publications on this Publisher), connect to the Distributor, open the Publisher and Distributor Properties dialog box, click on the Publishers tab, select this Publisher, and then click the browse button (. . .).

Generate snapshots in the following location

Enter the folder location where you want snapshot files stored.

(. . .)

Browse for the folder location where you want snapshot files stored.

Compress the snapshot files in this location

Indicates that the snapshot files will be compressed when they are created.

Subscribers can access this folder using File Transfer Protocol (FTP)

Specify that the snapshot folder can be accessed using FTP. Enabling this option allows the Distribution Agents or Merge Agents to use FTP to access the snapshot files, but you must ensure that the specified folder is under the FTP home directory on the Distributor.

FTP server name

Enter the server name for the FTP site.

Port

Enter the port number for the FTP site.

Client path to this folder from the FTP root

Enter the path from the FTP home directory. This folder is used by the Distribution Agents or Merge Agents at the Subscriber to access the snapshot folder after a connection to the FTP server's root folder has been established.

Login name

Enter the login name for the account.

Password

Enter the password for the account.

Confirm password

Enter the password for the account again to confirm spelling.

See Also

Applying the Initial Snapshot

Alternate Snapshot Locations

Compressed Snapshot Files

Transferring Snapshots


publication Properties, Publication Access List Tab

The following options are available on the Publication Access List tab of the publication Properties dialog box.

Options

Login name

View the login name for the account.

Type

View the type of user account.

Add

Add a new login to the list. You can add only those login names that are already defined at both the Publisher and Distributor.

Remove

Remove the selected login from the list.

Remove All

Remove all the logins from the list.

Note Before an enabled Subscriber can connect to a Publisher, the login for the Subscriber must be present in the Publisher's publication access list

See Also

Publication Access Lists


publication Properties, Status Tab

The following options are available on the Status tab of the publication Properties dialog box.

Options

Last run

View the last date and time the Snapshot Agent was run.

Run Agent Now

Run the Snapshot Agent on demand.

Next run

View the next date and time the Snapshot Agent is scheduled to run.

Agent Properties

View the properties of the Snapshot Agent job.

Explore Snapshot

Start Windows Explorer at the snapshot folder for this Publisher so that you can view, copy, or move the current snapshot files.

Service

View the service required to be running on the indicated server.

Status

View the status of the service (stopped, starting, or started).

Start Service

Start the selected service on the indicated server.

Refresh Status

Refresh the status of the selected service.

See Also

Administering and Monitoring Replication

Snapshot Agents


publication Properties, Sync Partners Tab

Subscribers to merge publications can synchronize with servers other than the Publisher at which the subscription originated. Synchronizing with alternate partners provides the ability for a Subscriber to synchronize data even if the primary Publisher is unavailable. This feature is also useful when mobile Subscribers have access to a faster or more reliable network connection with an alternate synchronization partner.

Note Subscribers must be running SQL Server® 2000 in order for you to enable and use alternate synchronization partners. If you have specified Subscriber types other than those running SQL Server 2000, you will be warned that the Subscriber Types option will be changed to servers running SQL Server 2000 and existing subscriptions from that do not meet this requirement will become invalid.

Potential synchronization partners can be the original Publisher of this publication, global Subscribers to this publication (which do not use the Publisher as a proxy when resolving data conflicts), and republishers of this publication.

The following options are available on the Sync Partners tab of the publication Properties dialog box.

Options

Allow Subscribers to synchronize with other partners than the Publisher from which the subscription was created

Enable using alternate synchronization partners.

(checkbox)

Select which potential alternate synchronization partners are enabled for use with this publication. The original Publisher for this publication cannot be disabled.

Partner

The name of the server identified as an alternate synchronization partner for this publication.

Publication Database

The publication database on the alternate synchronization partner which has the necessary data for this publication.

Publication

The name of the publication on the alternate synchronization partner.

See Also

Alternate Synchronization Partners

How Alternate Synchronization Partners Works

Merge Replication


heterogeneous publication Properties, General Tab

The following options are available on the General tab of the heterogeneous publication Properties dialog box.

Options

Publication name

View the name of the publication.

Database name

View the name of the database.

Description

View the description of the publication.

Publication type

View the type of publication (snapshot or transactional).

Publisher name

View the name of the Publisher.

Vendor name

View the name of the vendor who created the publication.

Distribution database

View the name of the distribution database for this publication.

Note Properties of heterogeneous Publishers and publications can only be created programmatically and cannot be set through the Microsoft® SQL Server user interface.

See Also

Heterogeneous Publishers


heterogeneous publication Properties, Subscription Options Tab

The following options are available on the Subscription Options tab of the publication Properties dialog box.

Options

Allow only enabled Subscribers to create pull subscriptions

View whether those Subscribers who have been specifically enabled are allowed to create pull subscriptions to the publication.

Allow both anonymous and enabled Subscribers to pull subscriptions

View whether those Subscribers who have been specifically enabled and any anonymous Subscribers are allowed to create pull subscriptions to the publication.

Use a Distribution Agent that is independent of other publications from this database

View whether the publication uses a separate Distribution agent. Having all the publications at the Publisher use the same Distribution Agent reduces the resource demands and increases performance at the Distributor. However, if your application requires immediate synchronization or allows anonymous subscriptions, you must have a separate Distribution Agent for this publication.

Snapshot files are always available to immediately initialize new subscriptions

View whether a new subscription can be immediately initialized from the snapshot stored at the Distributor.

Allow the Internet to be used to create and synchronize subscriptions

View whether Subscribers can create and synchronize their subscriptions over the Internet.

See Also

Heterogeneous Publishers


heterogeneous publication Properties, Subscriptions Tab

The following options are available on the Subscriptions tab of the heterogeneous publication Properties dialog box

Options

Subscription name

View the name of the subscription.

Type

View the type of subscription (push or pull).

All Articles

View whether this subscription contains all articles in the publication. This option is displayed only for snapshot and transactional publications.

Push New

Create a new push subscription at one or more Subscribers.

Properties

Display the properties of the subscription.

Delete

Delete the subscription.

See Also

Heterogeneous Publishers


Choose a Destination, Define Transformation of Published Data Wizard

The following options are available on the Choose a Destination page of the Define Transformation of Published Data Wizard.

Options

Destination

Choose the data-specific driver that matches the data storage format of the destination.

Server

Select the name of the server that will receive the transform data.

File Name

Specify the path and file name of where the data being imported is to be stored (for example, C:\MyData.xls, \\Sales\Database\Northwind.mdb). This option is available if Microsoft Jet 4.0 database is selected as the destination.

(. . .)

Click to browse for the Jet .mdb database file. This option is available if Microsoft Jet 4.0 database is selected as the destination.

Use Windows Authentication

Select to connect to the destination using Windows Authentication. This option is available for SQL Server destination databases.

Use SQL Server Authentication

Select to connect to the destination using SQL Server Authentication. This option is available for SQL Server destination databases.

Login

Enter the login name for the account. This option is available for SQL Server destination databases.

Password

Enter the password for the account. This option is available for SQL Server destination databases.

Database

Select the destination database. This option is only available for SQL Server destination databases.

Refresh

Click to refresh the database list. This option is only available for SQL Server destination databases.

Advanced Connection Properties

Shows the advanced properties that may be available depending on your destination data source.

See Also

DTS Basics

Transforming Published Data


Define Transformations

The following options are available on the Define Transformations page of the Define Transformation of Published Data Wizard.

Options

Source table (Publisher)

View the source table name at the Publisher.

Table name (Subscriber)

View the destination table name at the Subscriber.

Transform (. . .)

Click on the transform button (. . .) to create column mappings or transformations based on scripts.

See Also

DTS Basics

Transforming Published Data


Column Mappings and Transformations

This page allows you to define the column mappings and transformation scripts that will occur as the data is published.

Column Mappings tab

Use this tab to specify how to treat the destination table and to specify column attributes on any newly created table.

Options

Drop the existing table and re-create it

Drop the destination table and re-create it before moving data into it. All existing data in the destination table and any indexes are destroyed.

Keep the existing table unchanged

Keep the destination table and do not change it.

Delete all data in the existing table

Drop the data at the destination table.

Mappings

Edit the cells in the table. The table does not list the order in which the destination columns will appear, but rather lists each destination column alongside each source column to which it maps.

For each column in the Mappings table, you can set the following properties:

Source
Choose the column name in the source table to copy to the destination. Click <ignore> on the source column name to set the destination column to NULL for a new table. If the table already exists, the data will be NULL if allowed, or set to its default value if one was defined. If the destination is defined as NOT NULL, clicking <ignore> in the source column results in an error when the package is executed if no default value is specified for the destination column.

If you copy a source column defined as an identity column, the data will not be copied unless the Enable identity insert check box is selected.

If you copy a source column defined with user-defined data types to a new table, the data type of the destination column is the system-defined data type that corresponds to the user-defined data type.

You may change the following properties only if a new destination table is being created.

Destination
Choose the column name in the destination table to receive the source data. Click <ignore> to prevent the source column from being created in the destination table when creating a new table. If you want to remove a column from an existing table, click <ignore> in the destination column, but also select the Drop and re-create destination table check box in this dialog box. This will re-create the table with the columns specified. Existing data and indexes in the table will be lost.
Type
Select a data type for the destination column. The default setting matches the data type of the destination column to the source.
Nullable
Specify if destination can allow null values.
Size
Specify the length of the Destination column, in units corresponding to the data type. The value is only applicable for the char, varchar, nchar, nvarchar, binary, and varbinary data types. Specifying a size smaller than the length of the source can result in data truncation.
Precision
Enter the maximum number of decimal digits that can be stored to the left and to the right of the decimal point. This option applies only to decimal and numeric data types.
Scale
Enter the maximum number of decimal digits that are stored to the right of the decimal point. The number must be less than or equal to the number in the Precision column. This option applies only to decimal and numeric data types.
Transformations tab

Use this tab to specify whether unique transformation code must be written. The column mappings set on the Column Mappings tab are reflected in code shown in the text area.

Options

Copy the source column directly

Copy the source column to the destination tables without changing the data or the source and destination mappings.

Transform data using the following script

Edit the script in the text area to customize the columns before copying them from the source to the destination. For complex transformations, consider using DTS Designer, which offers support for Microsoft ActiveX® scripting.

Advanced

Display the Advanced Transformation Properties dialog box, where you can set transformation flags. These provide varying levels of protection from conversion and data loss.

See Also

DTS Basics

Transforming Published Data


DTS Package Location

The following options are available on the DTS Package Location page of the Define Transformation of Published Data Wizard.

Options

At the Distributor

Select to save the DTS package at the Distributor.

At the Subscriber

Select to save the DTS package at the Subscriber.

Use Windows Authentication

Select to connect to the selected server using Windows Authentication. This option is available for SQL Server destination databases.

Use SQL Server Authentication

Select to connect to the selected server using SQL Server Authentication. This option is available for SQL Server destination databases.

Login

Enter the login name for the account. This option is available for SQL Server destination databases.

Password

Enter the password for the account. This option is available for SQL Server destination databases.

See Also

DTS Basics

Transforming Published Data


DTS Package Identification

The following options are available on the DTS Package Identification page of the Define Transformation of Published Data Wizard.

Options

Package Name

Specify the name of the DTS package.

Description

Enter a description for the DTS package.

Owner password (allows editing and execution)

Enter an owner password for this DTS package. When this password is used, the DTS package can be edited and executed.

User password (allows execution).

Enter an owner password for this DTS package. When this password is used, the DTS package can be executed but not edited.

See Also

DTS Basics

Transforming Published Data


Specify Filter Values

The following options are available on the Specify Filter Values page of the Create Dynamic Snapshot Job Wizard.

Options

Value of HOST_NAME()

Enter the value of the system function HOST_NAME() if it is used to dynamically filter the merge publication. This value will identify the partition of data for the dynamic snapshot.

Value of suser_sname(), the login used by Subscriber(s) to connect to the Publisher

Enter the value of the system function SUSER_SNAME() if it is used to dynamically filter the merge publication. This value will identify the partition of data for the dynamic snapshot.

See Also

Dynamic Filters

Dynamic Snapshots


Specify Snapshot File Location

On the Specify Snapshot File Location page, type the path to the folder where you want snapshot files saved or click the browse button (...) and browse for the folder location. Using the alternate snapshot location feature, you can specify the snapshot folder location on the network, on removable media or on an FTP server.

The following options are available on the Specify Snapshot File Location page of the Create Dynamic Snapshot Job Wizard.

Options

Network path to the snapshot folder

Enter the path and snapshot folder location. Do not specify a foler that is used for other snapshots.

(. . .)

Browse to specify the snapshot folder location.

See Also

Dynamic Filters

Dynamic Snapshots


Set Job Schedule

On the Set Job Schedule page, select Run the job on the following schedule, and then select Change to specify a schedule for when the dynamic snapshot will be generated, or select Run the Job On demand only to control the dynamic snapshot agent job manually.

Select the Create the first snapshot immediately check box to generate the dynamic snapshot immediately.

See Also

Dynamic Filters

Dynamic Snapshots


Pull Subscription Properties, General Tab

The following options are available on the General tab of the Pull Subscription Properties dialog box.

Options

Subscription to publication

View the name of the publication.

Publisher

View the name of the Publisher.

Publisher database

View the name of the Publisher database.

Description

View the description of the publication.

Anonymous

View whether the subscription is anonymous.

Immediate updating subscription

View whether the subscription allows immediate updates at the Subscriber. This option is not displayed for merge publications.

Queued updating subscription

View whether the subscription allows queued updates at the Subscriber or whether queued updating as a failover to be used when an immediate update fails. This option is not displayed for merge publications.

Priority when resolving data conflicts

View the priority value used when resolving conflicts ("Use the priority of the Publisher" or a numeric value). This option is displayed only for merge publications. This option is not displayed for snapshot or transactional publications.

See Also

Pull Subscriptions

Subscribing to Publications


Pull Subscription Properties, Synchronization Tab (Snapshot or Transactional Publication)

The following options are available on the Synchronization tab of the Pull Subscription Properties dialog box.

Options

Last Updated

Time and date of the last synchronization

Distribution Agent Properties

View or modify the Distribution Agent properties

Enable synchronization using Windows Synchronization Manager

Allows you to use Windows Synchronization Manager to synchronize this pull subscription.

Run the agent at the Subscriber

Enable if you want to run the agent at the Subscriber. This is selected by default for pull subscriptions. You can also offload agent processing to the Distributor but retain agent administration at the Subscriber.

Run the agent at the Distributor

Enable if you want to run the agent at the Distributor. Selecting this offloads the agent processing, but agent administration is performed at the Subscriber.

Network machine name of Distributor

Verify or enter the network machine name of the Distributor if you are offloading agent processing to the Distributor.

Verify agent

Click to verify that the agent runs at the Distributor.

Immediate updating (using MSDTC)

Select to invoke immediate updating for this subscription. This option is displayed for a snapshot or transactional publication and subscription configured to use both immediate updating and queued updating.

Queued updating (using Microsoft Message Queuing or a SQL Server queue)

Select to invoke queued updating for this subscription. This option is displayed if the publication and subscription are configured to use both immediate updating and queued updating.

See Also

Remote Agent Activation

Updatable Subscriptions

Windows Synchronization Manager


Pull Subscription Properties, Synchronization Tab (Merge Publication)

The following options are available on the Synchronization tab of the Pull Subscription Properties dialog box.

Options

Agent Properties

View or modify the property of the Distribution or Merge Agent.

View Conflicts

View conflicts at the Subscriber.

Enable synchronization using Windows Synchronization Manager

Allows you to use Windows Synchronization Manager to synchronize this pull subscription.

Resolve conflicts automatically

Indicates that Microsoft® SQL Server™ 2000 will resolve conflicts encountered during merge replication synchronization according to the conflict resolution chosen when the publication was created.

Resolve conflicts interactively (articles must support interactive resolution)

Select if you want to use the interactive resolver to resolve conflicts encountered during merge replication synchronization.

Run the agent at the Subscriber

Enable if you want to run the agent at the Subscriber. This is selected by default for pull subscriptions. You can also offload agent processing to the Distributor, but retain agent administration at the Subscriber.

Run the agent at the Distributor

Enable if you want to run the agent at the Distributor. This is selected by default for pull subscriptions. Selecting this offloads the agent processing, but agent administration is performed at the Subscriber.

Network machine name of Distributor

Verify or enter the network machine name of the Distributor if you are offloading agent processing to the Distributor.

Verify agent

Click to verify that the agent runs at the Distributor.

See Also

Interactive Resolver

Merge Replication Conflict Detection and Resolution

Remote Agent Activation

Windows Synchronization Manager


Pull Subscription Properties, Security Tab

The following options are available on the Security tab of the Pull Subscription Properties dialog box.

Options

Impersonate the SQL Server Agent account on server

Use the same Windows Authentication account used by SQL Server Agent on the Subscriber.

Use SQL Server Authentication of this account

Use SQL Server Authentication of a specified account to login to the Subscriber.

Login name

Enter the login name for the account.

Password

Enter the password for the account.

Confirm password

Enter the password for the account again to confirm spelling.

Use the same login as for the Distributor

Use the same account to log into the Publisher as used to log into the Distributor. This option is only available for merge publications.

Use a predefined linked server or remote server login

Specifies that a predefined linked server or remote server login will be used. This option is displayed only for snapshot and transactional publications that allow updatable subscriptions.

Impersonate the SQL Server Agent account on server

Use the same Windows Authentication account used by SQL Server Agent on the Publisher. This option is displayed only for merge publications.

Use SQL Server Authentication of this account

Use SQL Server Authentication of a specified account to login to the Publisher.

Login name

Enter the login name for the account.

Password

Enter the password for the account.

Confirm password

Enter the password for the account again to confirm spelling.

See Also

Connecting to the Distributor

Replication Security


Pull Subscription Properties, Snapshot Location Tab

The following options are available on the Snapshot Location tab of the Pull Subscription Properties dialog box.

Options

Get the snapshot from the Publisher's normal snapshot folder

Retrieves the snapshot from the default snapshot folder location.

Get the snapshot from the following folder

Enter the folder where snapshots are stored.

This is a snapshot for a dynamically filtered publication

Indicates that the snapshot being retrieved is a dynamic snapshot. This option is not displayed for snapshot or transactional publications.

Download the snapshot using File Transfer Protocol (FTP)

Use FTP instead of the regular protocol for downloading files to this server.

Temporary working folder

Enter the folder that you want to use as a temporary working folder. To use the Windows temporary folder, leave this option blank.

See Also

Alternate Snapshot Locations

Applying the Initial Snapshot


Pull Subscription Properties, Snapshot Delivery Tab (SQL Server 7.0)

The following options are available on the Snapshot Delivery tab of the Pull Subscription Properties dialog box.

Options

Get the snapshot from the Publisher's normal snapshot folder

Retrieves the snapshot from the default snapshot folder location.

Get the snapshot from the following folder

Enter the folder where snapshots are stored.

Download the snapshot using FTP (File Transfer Protocol) with the following properties:

Use FTP instead of the regular protocol for downloading files to this server.

Server address of the Distributor

Enter the network address of the FTP service at the Distributor.

Login

Enter the username used to connect to the FTP service.

Port

Enter the port number of the FTP service at the Distributor.

Password

Enter the user password used to connect to the FTP service.

Confirm password

Enter the password again to confirm spelling.


Generate SQL Scripts, General Tab

The following options are available on the General tab of the Generate SQL Scripts dialog box.

Options

Distributor properties

Script the configuration of the Distributor. If the server is both a Publisher and Distributor, the script includes all configurations. If the server is just a Publisher, the script contains just the pointer to the Distributor.

Publications in these databases

Script the publications in the selected databases.

Pull Subscriptions in these selected databases

Script the pull subscriptions in the selected databases.

All

Select all the databases in the list.

None

Clear all the databases in the list.

Enable or create the selected components

Script the steps to enable or create the components in the selected databases. Also adds a Distributor, if that is selected.

Disable or drop the selected components

Script the steps to disable or drop the components in the selected databases. Also drops a Distributor, if that is selected. Scripting these steps will not drop the publications or pull subscriptions or disable the Distributor.

Script creation of replication jobs

If selected, SQL Server Enterprise Manager will attempt to create scripts of replication jobs along with configuration of the Distributor, publications, or pull subscriptions if indicated. However, you do not have privileges to view jobs using msdb.dbo.sp_help_job, SQL Server Enterprise Manager may fail to create the job script. Typically, members of the sysadmin fixed server role or the owner of jobs have privilege to view jobs using msdb.dbo.sp_help_job. This option is not available for servers running SQL Server 7.0 or earlier versions.

Preview

Preview and modify the script before it is saved. If you make changes to the preview script, you must click Save As in the Preview dialog box to save those changes.


Generate SQL Scripts, File Options Tab

The following options are available on the File Options tab of the Generate SQL Scripts dialog box.

Options

MS-DOS text

Create the script using the OEM character set.

Windows text

Create the script using the ANSI character set.

International text

Create the script using the Unicode character set.

Append script to file

Add the script to the end of the file you specify.


Agent Profiles

The following options are available in the Agent Profiles dialog box.

Options

Default

Select the profile to be used when creating new agents of the type indicated. This option is displayed only when viewing the default agent profiles dialog box in the Publisher and Distributor Properties.

Use

Select the profile to use for this agent. This option is displayed only when viewing the Agent Profiles for an existing agent.

Profile name

View the name of the agent profile.

Type

View the type of agent profile (user or system).

Description

View the description of the profile.

View Details

Display the parameters of the selected profile. This option is displayed only if a system profile is selected.

Modify Profile

Display a dialog box for modifying a selected profile. This option is displayed only if an existing user profile is selected.

New Profile

Display a dialog box for creating a new profile based on the selected profile. The starting values for the parameters are the values of whatever profile you have selected. The new profile does not automatically become the profile to be used.

Delete

Delete the selected user profile from the list. System profiles cannot be deleted.

Change all existing . . . Agents to use the selected profile

Change all agents of the indicated type to use the Default Profile. Agents that run continuously must be stopped and restarted before the new profile will be used. This option is displayed only when viewing the default agent profiles dialog box from the Publisher and Distributor Properties.


Refresh Rate and Settings, General Tab

The following options are available on the General tab of the Refresh Rate and Settings dialog box.

Options

Refresh results pane

Update the detailed view displayed by the Replication Monitor periodically. Set the number of seconds between refreshes.

Refresh server tree

Update the items displayed under Replication Monitor in the server tree periodically. Set the number of seconds between refreshes.

Inactivity threshold

Set the minutes in which an agent has not logged any activity in order for it to be considered not functioning.

Anonymous subscriptions

Select whether you want anonymous subscriptions and the agents for the subscriptions to show in Replication Monitor.


Refresh Rate and Settings, Performance Monitor Tab

The following options are available on the Performance Monitor tab of the Refresh Rate and Settings dialog box.

Options

Path to performance monitor settings

Specify the path and name of the file containing the Windows Performance Monitor settings for replication agents. This file must already exist and is required for the Replication Monitor to use the Windows Performance Monitor.


Replication Monitor - Select Columns, Snapshot Agents Tab

The following options are available on the Snapshot Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Publisher | Publisher that created the publication.
Publication database | Name of the publication database.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (cmds/sec) | Ratio of delivered commands to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
#Trans | The number of transactions delivered to the Distributor.
#Cmds | The number of commands delivered to the Distributor.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Log Reader Agents Tab

The following options are available on the Log Reader Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Database | Name of the Publisher database.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (cmds/sec) | Ratio of delivered commands to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Latency (msec) | The current amount of time, in milliseconds, elapsed from when transactions are applied at the Publisher to when they are delivered to the Distributor.
#Cmds | The number of commands delivered to the Distributor.
#Trans | The number of transactions delivered to the Distributor.
Avg. #Cmds | The average number of commands per transaction delivered to the Distributor for the session.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Distribution Agents Tab

The following options are available on the Distribution Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Publisher | Publisher that created the publication.
Publisher DB | Name of the Publisher database.
Subscription | Name of the subscription.
Type | Type of subscription.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (cmds/sec) | Ratio of delivered commands to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Latency (msec) | The current amount of time, in milliseconds, elapsed from when transactions are delivered to the Distributor to when they are applied at the Subscriber.
#Trans | The number of transactions delivered to the Subscriber.
#Cmds | The number of commands delivered to the Subscriber.
Avg. #Cmds | The average number of commands per transaction delivered to the Subscriber for the session.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Merge Agents Tab

The following options are available on the Merge Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Publisher | Publisher that created the publication.
Publication database | Name of the publication database.
Subscription | Name of the subscription.
Type | Type of subscription.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (rows/sec) | Ratio of delivered rows to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Publisher inserts | Number of INSERT commands applied at the Publisher.
Publisher updates | Number of UPDATE commands applied at the Publisher.
Publisher deletes | Number of DELETE commands applied at the Publisher.
Publisher conflicts | The number of conflicts occurring at the Publisher during the merge process.
Subscriber inserts | Number of INSERT commands applied at the Subscriber.
Subscriber updates | Number of UPDATE commands applied at the Subscriber.
Subscriber deletes | Number of DELETE commands applied at the Subscriber.
Subscriber conflicts | The number of conflicts occurring at the Subscriber during the merge process.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Transactional Publication View Tab

The following options are available on the Trans Publication View tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Type | Type of subscription.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (cmds/sec) | Ratio of delivered commands to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Latency (msec) | For the Snapshot or Log Reader Agent, this is the current amount of time, in milliseconds, elapsed from when transactions are applied at the Publisher to when they are delivered to the Distributor. For the subscription, this is the current amount of time, in milliseconds, elapsed from when transactions are delivered to the Distributor to when they are applied at the Subscriber.
#Trans | For the Snapshot or Log Reader Agent, this is the number of transactions delivered to the Distributor. For the subscription, this is the number of transactions delivered to the Subscriber.
#Cmds | For the Snapshot or Log Reader Agent, this is the number of commands delivered to the Distributor. For the subscription, this is the number of commands delivered to the Subscriber.
Avg. #Cmds | For the Snapshot or Log Reader Agent, this is the average number of commands per transaction delivered to the Distributor for the session. For the subscription, this is the average number of commands per transaction delivered to the Subscriber for the session.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Merge Publication View Tab

The following options are available on the Merge Publication View tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Type | Type of subscription.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time the action was taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Delivery rate (rows/sec) | Ratio of delivered rows to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Publisher inserts | Number of INSERT commands applied at the Publisher.
Publisher updates | Number of UPDATE commands applied at the Publisher.
Publisher deletes | Number of DELETE commands applied at the Publisher.
Publisher conflicts | The number of conflicts occurring at the Publisher during the merge process.
Subscriber inserts | Number of INSERT commands applied at the Subscriber.
Subscriber updates | Number of UPDATE commands applied at the Subscriber.
Subscriber deletes | Number of DELETE commands applied at the Subscriber.
Subscriber conflicts | The number of conflicts occurring at the Subscriber during the merge process.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Miscellaneous Agents Tab

The following options are available on the Miscellaneous Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Type | Type of miscellaneous agent.
Status | Status of the agent's last action.
Last action | Last action taken.
Start time | Time this session was started.
Duration | Duration of the agent session.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all the columns and list them in default order.


Replication Monitor - Select Columns, Queue Reader Agents Tab

The following options are available on the Queue Reader Agents tab of the Replication Monitor - Select Columns dialog box.

Option | Description
(check box) | Display the selected column in the result pane.
Status | Status of the agent's last action.
Last action | Last action taken.
Action time | Time at which the action was taken.
Start time | Time at which the session was started.
Duration | Duration of the agent session.
Delivery rate (cmds/sec) | Ratio of delivered commands to the duration of the agent. If the agent is still running, this value reflects a cumulative count from the beginning of the session.
Latency (msec) | Latency, in milliseconds, between when a transaction entered the queue and when it is applied at the Publisher.
#Cmds | Cumulative number of commands processed in the session.
#Trans | Cumulative number of transactions processed in the session.
Avg. #Cmds | The average number of commands.
Move Up | Move the selected column higher in the list. It also moves the column to the left in the result pane.
Move Down | Move the selected column lower in the list. It also moves the column to the right in the result pane.
Reset | Select all columns and list them in default order.


Add Column to Replicated Table

The following options are available on the Add Column to Replicated Table dialog box.

Options

Table

View the name of the table on which a column will be added.

Column name

Enter the name of the new column.

Column definition (excluding the column name)

Enter the SQL syntax that defines the column including data type, constraints and properties. The column must either allow NULLs or have a specified default value.

Include the column in the following publications

Select the publications where this column will be automatically added.

Note If you are adding or dropping columns to a publishing table for a snapshot or transactional publication that allows data transformations, the schema change is not propagated to the Subscriber automatically. You will need to update the schema manually and regenerate the replication DTS package; otherwise the Distribution Agent may fail to apply subsequent modifications. For snapshot publications, you need to update only the schema if pre_creation_cmd is either TRUNCATE or DELETE, but not DROP.

See Also

Schema Changes on Publication Databases


Validate All Subscriptions

The following options are available on the Validate All Subscriptions dialog box for merge publications.

Options

Verify the row counts only

Validates data by calculating a rowcount at the Publisher and then comparing that value to the rowcount calculated at the Subscriber.

Verify the row counts and compare checksums to verify the row data

Validates data by calculating a rowcount and a checksum at the Publisher and then comparing those values to the rowcount and checksum calculated at the Subscriber. Because checksums can require large amounts of processor resources when validating a large data set, you may want to schedule validation to occur when there is the least activity on the servers used in replication.

Verify the row counts and compare binary checksums to verify the row data (all Subscribers are servers running SQL Server 2000)

Validates data by calculating a binary checksum at the Publisher and then comparing that value to the binary checksum calculated at the Subscriber.

See Also

Validating Replicated Data


Validate Subscriptions

The following options are available on the Validate Subscriptions dialog box for transactional publications.

Options

Validate all subscriptions

Select to validate all subscriptions for this publication.

Validate the following subscriptions

Select only those subscriptions for which you want to validate data.

Validation options

Click to see more options for validation including whether to calculate row count or checksum values.

See Also

Validating Replicated Data


Subscription Validation Options

The following options are available on the Subscription Validation Options dialog box for transactional publications.

Options

Compute a fast row count based on cached table information

Validates data by calculating a rowcount at the Publisher and then comparing that value to the rowcount calculated at the Subscriber. The rowcounts are based on cached table information rather than querying the tables directly.

Compute an actual row count by querying the tables directly

Validates data by calculating a rowcount at the Publisher and then comparing that value to the rowcount calculated at the Subscriber and querying the tables at each server directly.

Compute a fast row count; if differences are found, compute an actual row count

Validates data by calculating a fast rowcount based on cached table information. If changes are found, an actual rowcount is calculated by querying the tables directly.

Compare checksums to verify row data

Validates data by calculating a checksum at the Publisher and then comparing that value to the checksum calculated at the Subscriber.

This Subscriber is a server running SQL Server 2000, use a binary checksum

Validates data by calculating a binary checksum at the Publisher and then comparing that value to the binary checksum calculated at the Subscriber.

Stop the Distribution Agent after the validation has completed

Stops the Distribution Agent after any kind of validation has completed.


Enable Subscriber - ODBC Data Source

Select a data source name in the list of ODBC data source names. The following options are available on the Enable Subscriber – ODBC Data Source dialog box.

Options

Login name

Enter the login name for the Subscriber account (if one is required).

Password

Enter the password for the Subscriber account (if one is required).

Confirm password

Enter the password for the Subscriber account to confirm the password.

See Also

Heterogeneous Subscribers


Enable Subscriber - OLE DB Data Source

The following options are available on the Enable Subscriber – OLE DB Data Source dialog box.

Options

Add

Select to register a server running OLE DB data sources as linked servers.

Login name

Enter the login name for the Subscriber account (if one is required).

Password

Enter the password for the Subscriber account (if one is required).

Confirm password

Enter the password for the Subscriber account to confirm the password.

See Also

Heterogeneous Subscribers


Compatibility Level Warning

The Compatibility Level Warning dialog box alerts you to a change in the compatibility level required of Subscribers. Changing the compatibility level for Subscribers can cause some subscriptions to be deactivated; these subscriptions will need to be reinitialized.

For example, suppose you create a publication and specify that you will publish to Subscribers running Microsoft® SQL Server™ 2000 or to Subscribers running SQL Server 7.0, and then create the publication with one table article in it. Later, you open Publication Properties and select a view article to publish as part of the publication.

View articles can be published only with Subscribers running SQL Server 2000. If you have active subscriptions from Subscribers running SQL Server 7.0, and you choose to change the compatibility property by publishing the view, the subscriptions to the SQL Server 7.0 Subscriber will become inactive.

Select Do not warn me about changing this property again to disable the compatibility level warning during future changes that affect compatibility.

Select Do not warn me about changing any publication property again to disable all warnings resulting from a change in the Publication Properties.


Add Distributor to Monitor

Replication Monitor is a component of SQL Server Enterprise Manager designed for viewing the status of replication agents and troubleshooting potential problems at the Distributor. Replication Monitor shows up as a node in SQL Server Enterprise Manager when the server is enabled as a Distributor and the user is a member of the sysadmin fixed server role.

You can use Replication Monitor to:

  • View a list of Publishers, publications, and subscriptions to the publications that are supported by the Distributor.

  • View scheduled replication agents, and to monitor real-time status and history for each agent.

  • Set up and monitor alerts related to replication events.

  • Administering agents and subscriptions including starting and stopping agents and reinitializing subscriptions.

Registered servers

Select the server(s) you want to add to the Replication Monitor. Hold down the CTRL key or the Shift key to select multiple servers.

Register server

Click to specify a server to register in Enterprise Manager.


Run Agent at Subscriber

The following options are available on the Run Agent at Subscriber dialog box.

Options

Network name of the subscribing server

Enter the name of the Subscriber where the agent will run.

Verify Subscriber

Click to verify that the Subscriber is prepared to run the offloaded agent.

See Also

Remote Agent Activation


Attach Subscription Database

Use the Attach Subscription Database dialog box to specify the database file to attach. Subscriptions in this database will be created automatically for this Subscriber.

If you are attaching the subscription database at a local server, you will be able to specify the subscription database file, the name of the database to create and the location of the new database file to create.

If you are attaching the subscription database at a remote server, you will only be able to specify the subscription database file and the name of the database to create. The database file will automatically be created at the default location for the remote server.

See Also

Attachable Subscription Databases